package go;
import java.util.*;
import go.jugadores.*;

/**
 * @author  emi
 */
public class Partida{
	public static final String nomColores[] = {"blancas","negras"};
	/**
	 * @uml.property  name="tablero"
	 * @uml.associationEnd  
	 */
	private Tablero tablero;
	/**
	 * @uml.property  name="negras"
	 * @uml.associationEnd  
	 */
	private Jugador negras;
	/**
	 * @uml.property  name="blancas"
	 * @uml.associationEnd  
	 */
	private Jugador blancas;
	private ArrayList<Ficha> listaMovPartida;
	/**
	 * @uml.property  name="turno"
	 */
	private int turno;
	/**
	 * @uml.property  name="antes"
	 * @uml.associationEnd  
	 */
	private int numero_jugadas;//PONGO ESTA VARIABLE XK EN MI TABLERO COMO ES DE 9x9 EL JUGADOR NEGRO TIENE 41
	//FICHAS Y EL JUGADOR BLANCA 40 FICHAS, ES DECIR COMO MUCHO HAY 81 JUGADAS
	
	private Tablero antes;
	public Partida(Jugador negras, Jugador blancas, int tam){
		this.tablero=new Tablero(tam);
		this.listaMovPartida=new ArrayList<Ficha>();
		this.negras=negras;
		this.blancas=blancas;
		this.turno=2;
		this.numero_jugadas=0;
		this.antes=new Tablero(tam);
	}
	public Partida(Jugador negras, Jugador blancas, Tablero tablero){
		this.tablero=tablero;
		this.listaMovPartida=new ArrayList<Ficha>();
		this.negras=negras;
		this.blancas=blancas;
		this.turno=2;
		this.numero_jugadas=0;
		this.antes=tablero.copiaTablero();
	}
	
	/*ES EL COPIA PARTIDA QUE ME DABAN ESTA MAL, ASI QUE VOY A HACER YO EL 
	 * CONSTRUCTOR PARA HACER LA COPIA BIEN, TIENE QUE SER UNA COPIA DE TOD*/
	public Partida copiaPartida(){
		ArrayList<Ficha> lista=new ArrayList<Ficha>();
		Iterator<Ficha> i=this.listaMovPartida.iterator();
		while(i.hasNext()){
			Ficha ficha=i.next();
			lista.add(ficha);
		}
		Partida copia=new Partida(this.jugadorNegras(),this.jugadorBlancas(),this.getTablero().copiaTablero());
		copia.turno=this.turno;
		//copia.setAnterior(this.getAnterior().copiaTablero());
		copia.setListaMov(lista);
		copia.numero_jugadas=this.numero_jugadas;
		return copia;
	}
	
	/**
	 * @return
	 * @uml.property  name="tablero"
	 */
	public Tablero getTablero(){
		return this.tablero;
	}
	/**
	 * @param tab
	 * @uml.property  name="tablero"
	 */
	public void setTablero(Tablero tab){
		this.tablero=tab;
	}
	public Jugador jugadorNegras(){
		return this.negras;
	}
	public Jugador jugadorBlancas(){
		return this.blancas;
	}
	public Jugador jugadorActual(){
		if(turno==2)return negras;
		else return blancas;
	}
	public void addMov(Ficha ficha){
		this.listaMovPartida.add(ficha);
	}
	public ArrayList<Ficha> getListaMov(){
		return this.listaMovPartida;
	}
	public void setListaMov(ArrayList<Ficha> lista){
		this.listaMovPartida=lista;
	}
	/**
	 * @return
	 * @uml.property  name="turno"
	 */
	public int getTurno(){
		return turno;
	}
	
	public int getNumeroJugada(){
		return numero_jugadas;
	}
	
	public void setNumeroJugada(int num){
		this.numero_jugadas=num;
	}
	/**
	 * @param turno
	 * @uml.property  name="turno"
	 */
	public void setTurno(int turno){
		this.turno=turno;
	}
	public void cambiaTurno(){
		if(this.getTurno()==2)this.setTurno(1);
		else this.setTurno(2);
	}
	public Tablero getAnterior(){
		return this.antes;
	}
	public void setAnterior(Tablero antes){
		this.antes=antes;
	}
	public void estadoPartida(){
		this.getTablero().imprimeTablero();
	}
	public boolean puedoPoner(Ficha ficha){
		boolean puedo=false,ko=false;
		Tablero temp=getTablero().copiaTablero();
		if(temp.getPosicion(ficha)!=0) return false;
		int lib=cuentaLibertades(temp,ficha);
		ArrayList<Cerco> vecinos=mirarVecinos(temp,ficha);
		Cerco vecino=null;
		if(lib==0){
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				vecino=(Cerco)i.next();
				if(vecino.getAmo()==ficha.getColorFicha()){
					if(vecino.getLibertades()>1)puedo=true;
				}else{
					if(vecino.getLibertades()<2){
						temp.setPosicion(ficha);
						temp.setPosicion(vecino.getListaCruces().get(0).getFila(),vecino.getListaCruces().get(0).getColumna(),0);
						if(hayKo(temp)) ko=true;
						else puedo=true;
						temp.setPosicion(ficha.getFila(),ficha.getColumna(),0);
						temp.setPosicion(vecino.getListaCruces().get(0).getFila(),vecino.getListaCruces().get(0).getColumna(),vecino.getAmo());
					}
				}
			}
		}else puedo=true;
		if(ko)return false;
		return puedo;
	}
	public void poner(Ficha ficha){
		ArrayList<Cerco> vecinos=mirarVecinos(getTablero(),ficha);
		Cerco vecino=null;
		if(vecinos.isEmpty()){
			//System.out.println("sin vecinos");
			if(!getListaMov().isEmpty()) setAnterior(getTablero().copiaTablero());
			jugadorActual().addMovimiento(ficha);
			//YO LE SUMO LA JUGADAC
			this.setNumeroJugada(this.getNumeroJugada()+1);
			addMov(ficha);
			getTablero().setPosicion(ficha);
			Cerco yo=new Cerco(ficha,cuentaLibertades(getTablero(),ficha));
			getTablero().meteCerco(yo);
		}else{
			if(!getListaMov().isEmpty()) setAnterior(getTablero().copiaTablero());
			Cerco yo=new Cerco(ficha);
			getTablero().setPosicion(ficha);
			getTablero().meteCerco(yo);
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				//System.out.println("recorriendo a los vecinitos");
				vecino=i.next();
				if(vecino.getAmo()==ficha.getColorFicha()){
					yo.getListaCruces().addAll(vecino.getListaCruces());
					vecino.getListaCruces().clear();
					getTablero().sacaCerco(vecino);
				}else{
					vecino.setLibertades(vecino.getLibertades()-1);
					if(vecino.getLibertades()==0){
						capturarVecino(getTablero(),vecino);
						//Pongo el lugar ocupado por el vecino a 0
						Iterator<Cruce> j=vecino.getListaCruces().iterator();
						while(j.hasNext()){
							Cruce objetivo=(Cruce)j.next();
							getTablero().resetPosicion(objetivo);
						}
						//Lo elimino de la lista
						getTablero().sacaCerco(vecino);
					}
				}
			}
			jugadorActual().addMovimiento(ficha);
			//A VER QUE TAL
			this.setNumeroJugada(this.getNumeroJugada()+1);
			
			yo.setLibertades(cuentaLibertades(getTablero(),yo));
		}
		//System.out.println("blancos "+getTablero().getCercosBlancos());
		//System.out.println("negros "+getTablero().getCercosNegros());
	}
	public boolean ponerFicha(Ficha ficha){
		int lib=0;
		boolean puedo=false;
		//ArrayList<Cerco> blancos=tablero.getCercosBlancos();
		//System.out.println("Cercos blancos: "+tablero.getCercosBlancos());
		//ArrayList<Cerco> negros=tablero.getCercosNegros();
		//System.out.println("Cercos negros: "+tablero.getCercosNegros());
		//miramos si esta vacia
		Tablero temp=getTablero().copiaTablero();
		if(temp.getPosicion(ficha)!=0) return false;
		ArrayList<Cerco> mios=new ArrayList<Cerco>();
		ArrayList<Cerco> suyos=new ArrayList<Cerco>();
		ArrayList<Cerco> vecinos=new ArrayList<Cerco>();
		Cerco vecino=null;
		//mirarVecinoNorte
		if(temp.getPosicion(ficha.getFila()-1,ficha.getColumna())!=-1){
			//System.out.println("Dentro de los limites");
			if(temp.getPosicion(ficha.getFila()-1, ficha.getColumna())==0){
				//System.out.println("Vecino vacio");
				lib=lib+1;
				//System.out.println("libertades ficha dentro de mirar vecino: "+lib);
			}else{
				vecino=temp.getCerco(ficha.getFila()-1,ficha.getColumna(),temp.getPosicion(ficha.getFila()-1, ficha.getColumna()));
				if(!vecino.marcado()){
					if(vecino.getAmo()==ficha.getColorFicha())mios.add(vecino);
					else suyos.add(vecino);
					vecino.marcar();
				}
			}
		}
		//System.out.println("libertades ficha despues mirar norte: "+lib);
		//mirarVecinoSur
		if(temp.getPosicion(ficha.getFila()+1,ficha.getColumna())!=-1){
			//System.out.println("Dentro de los limites");
			if(temp.getPosicion(ficha.getFila()+1, ficha.getColumna())==0){
				//System.out.println("Vecino vacio");
				lib=lib+1;
				//System.out.println("libertades ficha dentro de mirar vecino: "+lib);
			}else{
				vecino=temp.getCerco(ficha.getFila()+1,ficha.getColumna(),temp.getPosicion(ficha.getFila()+1, ficha.getColumna()));
				if(!vecino.marcado()){
					if(vecino.getAmo()==ficha.getColorFicha())mios.add(vecino);
					else suyos.add(vecino);
					vecino.marcar();
				}
			}
		}
		//System.out.println("libertades ficha despues mirar sur: "+lib);
		//mirarVecinoEste
		if(temp.getPosicion(ficha.getFila(),ficha.getColumna()+1)!=-1){
			//System.out.println("Dentro de los limites");
			if(temp.getPosicion(ficha.getFila(), ficha.getColumna()+1)==0){
				//System.out.println("Vecino vacio");
				lib=lib+1;
				//System.out.println("libertades ficha dentro de mirar vecino: "+lib);
			}else{
				vecino=temp.getCerco(ficha.getFila(),ficha.getColumna()+1,temp.getPosicion(ficha.getFila(), ficha.getColumna()+1));
				if(!vecino.marcado()){
					if(vecino.getAmo()==ficha.getColorFicha())mios.add(vecino);
					else suyos.add(vecino);
					vecino.marcar();
				}
			}
		}
		//System.out.println("libertades ficha despues mirar este: "+lib);
		//mirarVecinoOeste
		if(temp.getPosicion(ficha.getFila(),ficha.getColumna()-1)!=-1){
			//System.out.println("Dentro de los limites");
			if(temp.getPosicion(ficha.getFila(), ficha.getColumna()-1)==0){
				//System.out.println("Vecino vacio");
				lib=lib+1;
				//System.out.println("libertades ficha dentro de mirar vecino: "+lib);
			}else{
				vecino=temp.getCerco(ficha.getFila(),ficha.getColumna()-1,temp.getPosicion(ficha.getFila(), ficha.getColumna()-1));
				if(!vecino.marcado()){
					if(vecino.getAmo()==ficha.getColorFicha())mios.add(vecino);
					else suyos.add(vecino);
					vecino.marcar();
				}
			}
		}
		//System.out.println("libertades ficha despues mirar oeste: "+lib);
		if(!mios.isEmpty())desmarcarVecinos(mios);
		if(!suyos.isEmpty())desmarcarVecinos(suyos);
		//System.out.println("libertades ficha al final: "+lib);
		//La posicion no tiene vecinos
		if(mios.isEmpty()&&suyos.isEmpty()){
			temp.setPosicion(ficha);
			temp.meteCerco(new Cerco(ficha,lib));
			jugadorActual().addCerco(new Cerco(ficha,lib));
			jugadorActual().addMovimiento(ficha);
			addMov(ficha);
			/*System.out.println("Anterior");
			if(getAnterior()!=null)getAnterior().imprimeTablero();
			System.out.println("Ahora");
			getTablero().imprimeTablero();
			System.out.println("Proximo");
			temp.imprimeTablero();*/
			setAnterior(this.getTablero().copiaTablero());
			tablero.setTablero(temp);
			return true;
		}
		//la posicion no tiene libertades
		if(lib==0){
			vecinos.addAll(mios);
			vecinos.addAll(suyos);
			//System.out.println("sin libertades");
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()&&!puedo){
				vecino=(Cerco)i.next();
				//System.out.println("Libertades vecino: "+vecino.getLibertades());
				if(vecino.getAmo()==ficha.getColorFicha()){
					if(vecino.getLibertades()>1)puedo=true;
				}else{
					if(vecino.getLibertades()<2)puedo=true;
				}
			}
		}
		//la posicion o tiene libertades o se puede poner
		if((lib>0)||puedo){
			temp.setPosicion(ficha);
			Cerco yo=new Cerco(ficha,lib);
			if(!mios.isEmpty())tratarMios(temp,yo,mios);
			temp.meteCerco(yo);
			if(!suyos.isEmpty())tratarSuyos(temp,yo,suyos);
			if(!getListaMov().isEmpty()){
				if(ko(temp)){
					if(!suyos.isEmpty()){
						Iterator<Cerco> i=suyos.iterator();
						while(i.hasNext()){
							vecino=i.next();
							//System.out.println(vecino);
							if(vecino.getLibertades()==0){
								temp.meteCerco(vecino);
								Cruce cruce=vecino.getListaCruces().get(0);
								jugadorActual().sumaCapturas(-1);
								trataVecinos(temp,cruce);
							}
							vecino.setLibertades(vecino.getLibertades()+1);
						}
					}
					temp.sacaCerco(yo);
					//System.out.println("blancos "+getTablero().getCercosBlancos());
					//System.out.println("negros "+getTablero().getCercosNegros());
					return false;
				}
			}
			System.out.println("%%%%%%%%%%vecino%%(((((((((((((((((((%%%%%%%%%%%"+vecino);
			jugadorActual().addMovimiento(ficha);
			jugadorActual().addCerco(new Cerco(ficha,lib));
			addMov(ficha);
			System.out.println("%%%%%%%%%%%blancas%%%%%%%%%%%%%"+jugadorBlancas().getListaCercos());
			System.out.println("%%%%%%%%%%%negras%%%%%%%%%%%%%"+jugadorNegras().getListaCercos());
			/*System.out.println("Anterior");
			if(getAnterior()!=null)getAnterior().imprimeTablero();
			System.out.println("Ahora");
			getTablero().imprimeTablero();
			System.out.println("Proximo");
			temp.imprimeTablero();*/
			setAnterior(this.getTablero().copiaTablero());
			tablero.setTablero(temp);
			return true;
		}
		return false;
	}
	public ArrayList<Cerco> mirarVecinos(Tablero temp,Ficha ficha){
		ArrayList<Cerco> lista=new ArrayList<Cerco>();
		Cerco vecino=null;
		//mirarVecinoNorte
		if(getTablero().getPosicion(ficha.getFila()-1,ficha.getColumna())>0){
			vecino=getTablero().getCerco(ficha.getFila()-1,ficha.getColumna(),getTablero().getPosicion(ficha.getFila()-1, ficha.getColumna()));
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		//mirarVecinoSur
		if(getTablero().getPosicion(ficha.getFila()+1,ficha.getColumna())>0){
			vecino=getTablero().getCerco(ficha.getFila()+1,ficha.getColumna(),getTablero().getPosicion(ficha.getFila()+1, ficha.getColumna()));
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		//mirarVecinoEste
		if(getTablero().getPosicion(ficha.getFila(),ficha.getColumna()+1)>0){
			vecino=getTablero().getCerco(ficha.getFila(),ficha.getColumna()+1,getTablero().getPosicion(ficha.getFila(), ficha.getColumna()+1));
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		//mirarVecinoOeste
		if(getTablero().getPosicion(ficha.getFila(),ficha.getColumna()-1)>0){
			vecino=getTablero().getCerco(ficha.getFila(),ficha.getColumna()-1,getTablero().getPosicion(ficha.getFila(), ficha.getColumna()-1));
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		desmarcarVecinos(lista);
		return lista;
	}
	public boolean ko(Tablero proximo){
		/*System.out.println("Anterior");
		getAnterior().imprimeTablero();
		System.out.println("Ahora");
		getTablero().imprimeTablero();
		System.out.println("Proximo");
		proximo.imprimeTablero();*/
		if(getAnterior().igualConf(proximo)){
			System.out.println("hay ko");
			return true;
		}
		return false;
	}
	public boolean hayKo(Tablero proximo){
		System.out.println("miramos hay ko");
		/*System.out.println("Anterior");
		getAnterior().imprimeTablero();
		System.out.println("Ahora");
		getTablero().imprimeTablero();
		System.out.println("Proximo");
		proximo.imprimeTablero();*/
		if(getAnterior().igualConf(proximo)){
			System.out.println("hay ko");
			return true;
		}
		return false;
	}
	public void tratarMios(Tablero temp, Cerco yo, ArrayList<Cerco> mios){
		Iterator<Cerco> i=mios.iterator();
		Cerco vecino=null;
		while(i.hasNext()){
			vecino=(Cerco)i.next();
			//Me aado las fichas del vecino
			yo.getListaCruces().addAll(vecino.getListaCruces());
			//Quito al vecino de la lista
			vecino.getListaCruces().clear();
			temp.sacaCerco(vecino);
		}
		//tengo el cerco totalmente montado sin libertades
		yo.setLibertades(cuentaLibertades(temp,yo));
	}
	public int cuentaLibertades(Tablero temp,Cerco yo){
		int lib=0,f,c;
		Iterator<Cruce> i=yo.getListaCruces().iterator();
		while(i.hasNext()){
			Cruce objetivo=i.next();
			//Miramos el vecino norte
			f=objetivo.getFila()-1;
			c=objetivo.getColumna();
			//Si el valor de la posicion es 0 la marcamos poniendolo a 9
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
			//Miramos el vecino sur
			f=objetivo.getFila()+1;
			c=objetivo.getColumna();
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
			//Miramos el vecino este
			f=objetivo.getFila();
			c=objetivo.getColumna()+1;
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
			//Miramos el vecino oeste
			f=objetivo.getFila();
			c=objetivo.getColumna()-1;
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
		}
		for(f=0;f<temp.getTam();f++){
			for(c=0;c<temp.getTam();c++){
				if(temp.getPosicion(f, c)==9){
					lib=lib+1;
					temp.resetPosicion(f,c);
				}
			}
		}
		return lib;
	}
	public int cuentaLibertades(Tablero tab, Ficha ficha){
		int lib=0;
		if(tab.getPosicion(ficha.getFila()-1,ficha.getColumna())==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila()+1,ficha.getColumna())==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila(),ficha.getColumna()-1)==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila(),ficha.getColumna()+1)==0)lib=lib+1;
		return lib;
	}
	public void tratarSuyos(Tablero temp, Cerco yo, ArrayList<Cerco> suyos){
		Iterator<Cerco> i=suyos.iterator();
		Cerco vecino=null;
		while(i.hasNext()){
			vecino=(Cerco)i.next();
			//Miro las libertades del vecino
			//si lo capturo, me sumo las piedras capturadas
			//y quito el cerco del tablero
			vecino.setLibertades(vecino.getLibertades()-1);
			if(vecino.getLibertades()==0){
				capturarVecino(temp,vecino);
				//Pongo el lugar ocupado por el vecino a 0
				Iterator<Cruce> j=vecino.getListaCruces().iterator();
				while(j.hasNext()){
					Cruce objetivo=(Cruce)j.next();
					temp.resetPosicion(objetivo);
				}
				//Lo elimino de la lista
				temp.getCercos(vecino.getAmo()).remove((Object)vecino);
			}
		}
	}
	public void capturarVecino(Tablero temp, Cerco capturado){
		//Me sumo las piezas capturadas
		this.jugadorActual().sumaCapturas(capturado.getListaCruces().size());
		Iterator<Cruce> j=capturado.getListaCruces().iterator();
		int f,c;
		while(j.hasNext()){
			Cruce objetivo=(Cruce)j.next();
			Cerco vecino=null;
			ArrayList<Cerco> vecinos=new ArrayList<Cerco>();
			//Miramos el vecino norte
			f=objetivo.getFila()-1;
			c=objetivo.getColumna();
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			//Miramos el vecino sur
			f=objetivo.getFila()+1;
			c=objetivo.getColumna();
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			//Miramos el vecino este
			f=objetivo.getFila();
			c=objetivo.getColumna()+1;
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			//Miramos el vecino oeste
			f=objetivo.getFila();
			c=objetivo.getColumna()-1;
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				vecino=(Cerco)i.next();
				vecino.setLibertades(vecino.getLibertades()+1);
				vecino.desmarcar();
			}
		}
	}
	public void desmarcarVecinos(ArrayList<Cerco> listaVecinos){
		Iterator<Cerco> i=listaVecinos.iterator();
		while(i.hasNext()){
			Cerco vecino=(Cerco)i.next();
			vecino.desmarcar();
		}
	}
	public void trataVecinos(Tablero tab, Cruce cruce){
		int f,c;
		Cerco vecino=null;
		f=cruce.getFila()-1;
		c=cruce.getColumna();
		if(tab.getPosicion(f, c)>0){
			vecino=tab.getCerco(f, c);
			vecino.setLibertades(vecino.getLibertades()-1);
		}
		f=cruce.getFila()+1;
		c=cruce.getColumna();
		if(tab.getPosicion(f, c)>0){
			vecino=tab.getCerco(f, c);
			vecino.setLibertades(vecino.getLibertades()-1);
		}
		f=cruce.getFila();
		c=cruce.getColumna()-1;
		if(tab.getPosicion(f, c)>0){
			vecino=tab.getCerco(f, c);
			vecino.setLibertades(vecino.getLibertades()-1);
		}
		f=cruce.getFila();
		c=cruce.getColumna()+1;
		if(tab.getPosicion(f, c)>0){
			vecino=tab.getCerco(f, c);
			vecino.setLibertades(vecino.getLibertades()-1);
		}
		
	}
	public boolean finPartida(){
		if((jugadorBlancas().getPasar()==true)&&(jugadorNegras().getPasar()==true))return true;
		return false;
	}
	public void calculaResultado(){
		//ES LA VARIANTE JAPONESA, PERO NO ESTA DEL TOD BIEN, YA QUE SOLO CUENTA
		//LOS CRUCES VACIOS QUE TIENEN VECINO, SI ESE CRUCE VACIO TIENE 2 VECINOS O MAS
		//DE UN COLOR CUENTA COMO QUE LA CONTROLA DICHO JUGADOR, PERO PUEDE PASAR QUE
		//VARIOS CRUCES NO TENGA VECION PERO ESTEN CONTROLADOR ALGUN JUGADOR. 
		int b=0,n=0;
		ArrayList<Cruce> vacios=new ArrayList<Cruce>();
		Tablero copia=this.getTablero();
		for(int f=0;f<copia.getTam();f++){
			for(int c=0;c<copia.getTam();c++){
				if(copia.getPosicion(f,c)==0)vacios.add(new Cruce(f,c));
			}
		}
		System.out.println("Cruces vacios :"+vacios.size());
		System.out.println("Cruces vacios :"+vacios);
		Iterator<Cruce> i=vacios.iterator();
		while(i.hasNext()){
			int vB=0;
			int vN=0;
			Cruce cruce=i.next();
			if(copia.getPosicion(cruce.getFila()-1,cruce.getColumna())==1)vB++;
			if(copia.getPosicion(cruce.getFila()+1,cruce.getColumna())==1)vB++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()-1)==1)vB++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()+1)==1)vB++;
			if(copia.getPosicion(cruce.getFila()-1,cruce.getColumna())==2)vN++;
			if(copia.getPosicion(cruce.getFila()+1,cruce.getColumna())==2)vN++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()-1)==2)vN++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()+1)==2)vN++;
			//LO HE CAMBIADO YO
			//if(vB>1)b++;
			//if(vN>1)n++;
			//tiene que tener mas de una y pero si tienen 2 cada uno no se cuenta
			if((vB>1)&&(vN<2))b++;
			if((vN>1)&&(vB<2))n++;
		}
		System.out.println("Territorio blanco:"+b);
		System.out.println("Territorio negro:"+n);
		this.jugadorBlancas().sumaCapturas(b);
		this.jugadorNegras().sumaCapturas(n);
		System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$");
	}
	public void parar(){
		this.jugadorActual().parar();
	}
}

