package go;
import java.util.*;
/**
 * @author  emi
 */
public class Tablero implements Cloneable{
	private int t;
	/**
	 * @uml.property  name="estado"
	 */
	private int[][] estado;
	/**
	 * @uml.property  name="cercosBlancos"
	 */
	private ArrayList<Cerco> cercosBlancos;
	/**
	 * @uml.property  name="cercosNegros"
	 */
	private ArrayList<Cerco> cercosNegros;
	public Tablero(int t){
		this.cercosBlancos=new ArrayList<Cerco>();
		this.cercosNegros=new ArrayList<Cerco>();
		this.t=t;
		this.estado=new int[t][t];
		for(int f=0;f<this.t;f++){
			for(int c=0;c<this.t;c++){
				//primero va la fila y luego la columna
				this.estado[f][c]=0;
			}
		}
	}
	public Tablero(int t, int[][] estado,ArrayList<Cerco>cercosBlancos,ArrayList<Cerco>cercosNegros){
		this.cercosBlancos=cercosBlancos;
		this.cercosNegros=cercosNegros;
		this.t=t;
		this.estado=new int[t][t];
		for(int f=0;f<this.t;f++){
			for(int c=0;c<this.t;c++){
				//primero va la fila y luego la columna
				this.estado[f][c]=estado[f][c];
			}
		}
	}
	public Tablero(Tablero tab){
		this.cercosBlancos=tab.getCercosBlancos();
		this.cercosNegros=tab.getCercosNegros();
		this.estado=tab.getEstado();
		this.t=tab.getTam();
	}
	
	//VOY HA HACER OTRO CONSTRUCTOR PARA COPIAR MI TABLERO VOY A PASAR UN TABLERO, Y UN ENTERO
	//QUE NO VALDRA PARA NADA PERO ES PARA DIFERENCIAR AL CONSTRUCTOR QUE YA ME HABIAN DADO
	
	public Tablero(Tablero t,int a){
		this.cercosBlancos=new ArrayList<Cerco>();
		this.cercosNegros=new ArrayList<Cerco>();
		this.estado=new int[t.getTam()][t.getTam()];
		this.t=t.getTam();
		for(int f=0;f<this.getTam();f++){
			for(int c=0;c<this.getTam();c++){
				this.estado[f][c]=t.getPosicion(f, c);
			}
		}
	
		if (t.getCercosBlancos()!=null) {
		//HASTA AQUI HEMOS COPIADO SOLO EL ESTADO y el tamao del tablero y ahora los cercos
		Iterator<Cerco>i=t.getCercosBlancos().iterator();
		while(i.hasNext()){
			Cerco cerco=i.next();
			Cerco prueba= new Cerco(cerco);
			this.cercosBlancos.add(prueba);
		}
		}
		
		if (t.getCercosNegros()!=null) {
		Iterator<Cerco>j=t.getCercosNegros().iterator();
		while(j.hasNext()){
			Cerco cerco=j.next();
			//System.out.println("Antes de copia cerco sus cruces son"+ cerco.getListaCruces());
			Cerco prueba= new Cerco(cerco);
			//System.out.println("Cuando sale de copia cerco sus cruces son"+ prueba.getListaCruces());
			this.cercosNegros.add(prueba);
		}
		}
	//Parece que ya tenemos la copia del tablero
	}
	//FIN HECHO POR MI
	
	//COPIA TABLERO HECHO POR EL, NO VALE PARA UTILIZARLO EN EL MINIMAX, YA QUE NO ESTA DEL 
	//TOD BIEN, XK HAY QUE HACER LA COPIA DE CERCO Y TOD ESO
	public Tablero copiaTablero(){
		Tablero copia=new Tablero(this.getTam());
		for(int f=0;f<this.getTam();f++){
			for(int c=0;c<this.getTam();c++){
				copia.estado[f][c]=this.getPosicion(f, c);
			}
		}
		Iterator<Cerco>i=this.getCercosBlancos().iterator();
		while(i.hasNext()){
			Cerco cerco=i.next();
			copia.cercosBlancos.add(cerco);
		}
		i=this.getCercosNegros().iterator();
		while(i.hasNext()){
			Cerco cerco=i.next();
			copia.cercosNegros.add(cerco);
		}
		return copia;
	}
	
	public void setTablero(Tablero nuevo){
		this.t=nuevo.getTam();
		this.estado=nuevo.getEstado();
		this.cercosBlancos=nuevo.getCercos(1);
		this.cercosNegros=nuevo.getCercos(2);
	}
	public int getTam(){
		return this.t;
	}
	/**
	 * @return
	 * @uml.property  name="estado"
	 */
	public int[][] getEstado(){
		return estado;
	}
	public int getPosicion(int f, int c){
		if((f<0)||(f>=this.getTam())||(c<0)||(c>=this.getTam())) return -1;
		return estado[f][c];
	}
	public int getPosicion(Ficha ficha){
		if((ficha.getFila()<0)||(ficha.getFila()>=this.getTam())||(ficha.getColumna()<0)||(ficha.getColumna()>=this.getTam())) return -1;
		return estado[ficha.getFila()][ficha.getColumna()];
	}
	public void setPosicion(int f, int c, int color){
		this.estado[f][c]=color;
	}
	public void setPosicion(Ficha ficha){
		this.estado[ficha.getFila()][ficha.getColumna()]=ficha.getColorFicha();
	}
	public void resetPosicion(Cruce cruce){
		this.estado[cruce.getFila()][cruce.getColumna()]=0;
	}
	public void resetPosicion(int f, int c){
		this.estado[f][c]=0;
	}
	public void meteFicha(Ficha ficha){
		this.estado[ficha.getFila()][ficha.getColumna()]=ficha.getColorFicha();
	}
	public void meteFicha(int f, int c, int color){
		this.estado[f][c]=color;
	}
	public void marcaPos(int f, int c){
		this.estado[f][c]=9;
	}
	public void imprimeTablero(){
		for(int f=0;f<this.t;f++){
			for(int c=0;c<this.t;c++){
				System.out.print(this.estado[f][c]+" ");
			}
			System.out.println();
		}
	}
	public void limpiaTablero(){
		for(int f=0;f<this.t;f++){
			for(int c=0;c<this.t;c++){
				this.estado[f][c]=0;
			}
		}
	}
	public boolean igualConf(Tablero tab){
		for(int f=0;f<this.t;f++){
			for(int c=0;c<this.t;c++){
				if(this.getPosicion(f, c)!=tab.getPosicion(f, c)) return false;
			}
		}
		return true;
	}
	public boolean equals(Object o){
		if(!(o instanceof Tablero)) return false;
		Tablero tab=(Tablero)o;
		if(this.t!=tab.t) return false;
		for(int f=0;f<this.t;f++){
			for(int c=0;c<this.t;c++){
				if(this.getPosicion(f,c)!=tab.getPosicion(f, c)){
					return false;
				}
			}
		}
		if(!this.getCercosBlancos().equals((Object)tab.getCercosBlancos()))return false;
		if(!this.getCercosNegros().equals((Object)tab.getCercosNegros()))return false;
		return true;
	}
	public Object clone(){
		int tClon=this.getTam();
		int[][] estadoClon=this.getEstado();
		ArrayList<Cerco> cercosBlancos=this.getCercos(1);
		ArrayList<Cerco> cercosNegros=this.getCercos(2);
		Tablero clon=new Tablero(tClon,estadoClon,cercosBlancos,cercosNegros);
		return (Object) clon;
	}
	/**
	 * @return
	 * @uml.property  name="cercosBlancos"
	 */
	public ArrayList<Cerco> getCercosBlancos(){
		return this.cercosBlancos;
	}
	/**
	 * @return
	 * @uml.property  name="cercosNegros"
	 */
	public ArrayList<Cerco> getCercosNegros(){
		return this.cercosNegros;
	}
	/**
	 * @param blancos
	 * @uml.property  name="cercosBlancos"
	 */
	public void setCercosBlancos(ArrayList<Cerco> blancos){
		this.cercosBlancos=blancos;
	}
	/**
	 * @param negros
	 * @uml.property  name="cercosNegros"
	 */
	public void setCercosNegros(ArrayList<Cerco> negros){
		this.cercosNegros=negros;
	}
	//Devuelve la lista de cercos del color que le pasamos
	public ArrayList<Cerco> getCercos(int color){
		ArrayList<Cerco> lista=null;
		if(color==1) lista=this.getCercosBlancos();
		else if(color==2) lista=this.getCercosNegros();
		return lista;
	}
	//Devuelve el cerco al que pertenece la ficha
	public Cerco getCerco(int f, int c, int color){
		ArrayList<Cerco> listaCercos=getCercos(color);
		Cerco cerco=null,dev=null;
		Cruce objetivo=new Cruce(f,c);
		Iterator<Cerco> i=listaCercos.iterator();
		while(i.hasNext()){
			cerco=(Cerco)i.next();
			ArrayList<Cruce> listaCruces=cerco.getListaCruces();
			if(listaCruces.contains((Object)objetivo)) dev=cerco;
		}
		return dev;
	}
	public Cerco getCerco(Ficha ficha){
		ArrayList<Cerco> listaCercos=getCercos(ficha.getColorFicha());
		Cerco cerco,dev=null;
		Iterator<Cerco> i=listaCercos.iterator();
		Cruce objetivo=ficha.getCruce();
		while(i.hasNext()){
			cerco=(Cerco)i.next();
			ArrayList<Cruce> listaFichas=cerco.getListaCruces();
			if(listaFichas.contains((Object)objetivo)) dev=cerco;
		}
		return dev;
	}
	//devuelve el cerco al que pertenece una posicion
	public Cerco getCerco(int f, int c){
		int color=this.getPosicion(f,c);
		if(color==-1)return null;
		ArrayList<Cerco> listaCercos=getCercos(color);
		Cerco cerco=null,dev=null;
		Cruce objetivo=new Cruce(f,c);
		Iterator<Cerco> i=listaCercos.iterator();
		while(i.hasNext()){
			cerco=(Cerco)i.next();
			ArrayList<Cruce> listaCruces=cerco.getListaCruces();
			if(listaCruces.contains((Object)objetivo)) dev=cerco;
		}
		return dev;
	}
	//mete la ficha en el cerco
	public void meteCerco(Cerco cerco){
		if(cerco.getAmo()==1) this.cercosBlancos.add(cerco);
		else this.cercosNegros.add(cerco);
	}
	public void sacaCerco(Cerco cerco){
		if(cerco.getAmo()==1) this.cercosBlancos.remove(cerco);
		else this.cercosNegros.remove(cerco);
	}
	
}