package go.interfaz;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import go.*;
import go.jugadores.*;

/**
 * Interfaz grfico del Otelo. Es la clase principal.
 */
public class Interfaz extends JFrame implements Runnable,ActionListener {
	//
	private static final long serialVersionUID = 1L;
	public static final long T_CHEQUEO = 100;
	private static final String HUMANO = "Humano";
	private static final String MAQUINA = "Mquina";
	private static String tipos[] = {HUMANO, MAQUINA};
	//
	/**
	 * @uml.property  name="p"
	 * @uml.associationEnd  
	 */
	private Partida p;
	private boolean pararPartida;
	private boolean alguienPasa;
	Thread t;
	//componentes grficos
	/**
	 * @uml.property  name="panel"
	 * @uml.associationEnd  
	 */
	private PanelTablero panel;
	private JLabel numBlancas;
	private JLabel numNegras;
	private Container pFichas;
	private JLabel mensajes;
	private JLabel ultimo;
	private JLabel resul=new JLabel("");
	private JButton nueva;
	private JButton pasar;
	private JButton parar;
	private JComboBox jB;
	private JComboBox jN;
	private JLabel fondo;
	//
	public Interfaz() {  
		//inicializar datos miembro
		pararPartida = false;
		//cuestiones grficas
		crearComponentes();
		//inicializar ventana
		setTitle("EgdgGo");
		setVisible(true);
		setLocation(300,100);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		pack();
	}
	//
	public Partida getPartida(){
		return this.p;
	}
	//
	private void crearComponentes() {
		//Creamos los botones
		nueva=new JButton("Nueva Partida");
		nueva.setActionCommand("nueva");
		nueva.addActionListener(this);
		//
		pasar=new JButton("Pasar");
		pasar.setActionCommand("pasar");
		pasar.setEnabled(false);
		pasar.addActionListener(this);
		//
		jB=new JComboBox(tipos);
		jN=new JComboBox(tipos);
		//
		Container pJugadores;
		//crear tablero
		panel = new PanelTablero();
		//jugadores
		pJugadores = Box.createHorizontalBox();
		pJugadores.add(new JLabel("Blancas: "));
		pJugadores.add(jB);
		pJugadores.add(Box.createHorizontalStrut(20));
		pJugadores.add(new JLabel("vs"));     
		pJugadores.add(Box.createHorizontalStrut(20));
		pJugadores.add(new JLabel("Negras: "));
		pJugadores.add(jN);
		//numero de fichas
		pFichas = Box.createHorizontalBox();
		pFichas.add(new JLabel("Blancas: "));
		numBlancas = new JLabel("-");
		pFichas.add(numBlancas);
		pFichas.add(Box.createHorizontalStrut(25));
		pFichas.add(new JLabel("Negras: "));
		numNegras = new JLabel("-");
		pFichas.add(numNegras);
		//
		mensajes = new JLabel("");
		ultimo=new JLabel("");
		//
		JPanel pDatos = new JPanel();
		pDatos.setLayout(new GridLayout(0,1));
		pDatos.add(nueva);
		pDatos.add(pasar);
		pDatos.add(resul);
		pDatos.add(pJugadores);
		pDatos.add(pFichas);
		pDatos.add(mensajes);
		pDatos.add(ultimo);
		pDatos.setBackground(Color.LIGHT_GRAY);
		pDatos.setBorder(BorderFactory.createLoweredBevelBorder());
		//panel de control
		JPanel pControl = new JPanel();
		//fondo= new JLabel();
		//pControl.add(fondo);
		pControl.add(pDatos, BorderLayout.CENTER);
		//fondo.setIcon(new ImageIcon(getClass().getClassLoader().getResource("/fondogo.jpeg").getImage));
		pControl.setBackground(Color.white);
		//pControl.setBorder(BorderFactory.createLineBorder(Color.yellow));
		//Panel del tablero
		JPanel pTab=new JPanel();
		pTab.add(panel,BorderLayout.CENTER);
		//aadir componentes a la ventana principal
		getContentPane().add(pTab, BorderLayout.CENTER);
		getContentPane().add(pControl, BorderLayout.EAST);
	}
	public void actionPerformed(ActionEvent e){
		if(e.getActionCommand().equals("nueva")){
			Jugador jBlancas=null;
			Jugador jNegras=null;
			pasar.setEnabled(true);
			jB.setEnabled(false);
			jN.setEnabled(false);
			nueva.setEnabled(false);
			String nomJugadorB=(String)jB.getSelectedItem();
			String nomJugadorN=(String)jN.getSelectedItem();
			if(nomJugadorB.equals(MAQUINA)) jBlancas=new JugadorMaquina(1);
			else jBlancas=new JugadorHumano(1);
			if(nomJugadorN.equals(MAQUINA)) jNegras=new JugadorMaquina(2);
			else jNegras=new JugadorHumano(2);
			p=new Partida(jNegras,jBlancas,9);
			panel.setPartida(p);
			panel.repaint();
			resul.setText("Empezamos...");
			jugar();
		}
		if(e.getActionCommand().equals("pasar")){
			Jugador jug=getPartida().jugadorActual();
			if(jug.getColorJug()==1)System.out.println("blancas pasan");
			else System.out.println("negras pasan");
			jug.setPasar(true);
			alguienPasa=true;
		}
	}
	protected void this_windowOpened(WindowEvent e) {
           centrarVentana();
	   }
	   private void centrarVentana() {
		   try{
           // Se obtienen las dimensiones en pixels de la pantalla.
           Dimension pantalla = Toolkit.getDefaultToolkit().getScreenSize();
           System.out.println(pantalla);
           int largoP=pantalla.width;
           int anchoP=pantalla.height;
           // Se obtienen las dimensiones en pixels de la ventana.
           Dimension ventana = getSize();
           System.out.println(ventana);
           int largoV=ventana.width;
           int anchoV=ventana.height;
           int posX=largoP/2-largoV*2;
           int posY=anchoP/2-anchoV*2;
           System.out.println(posX+":"+posY);
           // Una cuenta para situar la ventana en el centro de la pantalla.
           setLocation(posX,posY);
		   }catch(Exception ex){
			   System.out.println(ex);
		   }
	}
	public void jugar(){
		t = new Thread(this);
		t.start();  	
	}
	//
	public void run() {
		long tTotal;
		Jugador jAct;
		//
		pararPartida = false;
		alguienPasa=false;
		//actualizar nmero de fichas en el GUI
		numBlancas.setText(Integer.toString(p.jugadorBlancas().getNumeroCapturas()));
		numNegras.setText(Integer.toString(p.jugadorNegras().getNumeroCapturas()));
		//bucle de partida
		
		//YO XK COMO MUCHO EN UN TABLERO DE 9x9 PUEDE A VER 81 JUGADAS
		while(!p.finPartida() && (p.getNumeroJugada())<81){
			numBlancas.setText(Integer.toString(p.jugadorBlancas().getNumeroCapturas()));
			numNegras.setText(Integer.toString(p.jugadorNegras().getNumeroCapturas()));
			//actualiza turno en el GUI
			if (p.getTurno()==1) mensajes.setText("Turno de Blancas");
			else mensajes.setText("Turno de Negras");
			//pedirle al jugador actual su movimiento
			tTotal = 0;
			jAct = p.jugadorActual();
			jAct.hacerJugada(p);
			while ((jAct.getJugada()==null)&&(!pararPartida)&&(!alguienPasa)) {
				try {      	  	   
					Thread.sleep(T_CHEQUEO);
				}catch(InterruptedException ie) {}
				tTotal += T_CHEQUEO;
				if(jAct.getPasar()==true){
					//System.out.println("entramos?");
					alguienPasa=true;
					//OJOOOOOOOOOOOOOOOOOOOOOOOOO
					p.setNumeroJugada(p.getNumeroJugada()+1);
					System.out.println("estamos en la jugada"+ p.getNumeroJugada());
				}
			}
			if (pararPartida) {
			 	p.parar();
			 	System.out.println("pausa");
			 	return;
			}
//			if(jAct.getJugada()==null){
//				alguienPasa=true;
//			}
			

			if(alguienPasa){
				if(p.getTurno()==1)ultimo.setText("Blancas pasan, juegan negras");
				else ultimo.setText("Negras pasan, juegan blancas");
				p.cambiaTurno();
			}
			//comprobar si el movimiento es vlido
			if ((p.getTurno()==jAct.getColorJug())&&(p.puedoPoner(jAct.getJugada()))){
				System.out.println("movimiento valido");
				//System.out.println("B"+p.getTablero().getCercosBlancos());
				//System.out.println("N"+p.getTablero().getCercosNegros());
				//p.ponerFicha(jAct.getJugada());
				//System.out.println("despues de hacer jugada");
				//System.out.println("B"+p.getTablero().getCercosBlancos());
				//System.out.println("N"+p.getTablero().getCercosNegros());
				//actualizar tablero en el GUI
				p.poner(jAct.getJugada());
				panel.repaint();
				pFichas.repaint();
				ultimo.setText(jAct.getJugada().toString());
				p.jugadorBlancas().setPasar(false);
				p.jugadorNegras().setPasar(false);
				p.cambiaTurno();
				//p.getTablero().imprimeTablero();
				System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$");
			}else{
				 System.out.println("movimiento no valido");
			}
			//ESTO LO HE HECHO YO NO SE SI ESTA BIEN
			
			//if (p.getNumeroJugada()==81){
				//p.finPartida();
			//}
			
			alguienPasa=false;
		}
		finPartida();
		//pone en el GUI quin ha ganado
		/*if (j.getNumFichas(Juego.BLANCAS)>j.getNumFichas(Juego.NEGRAS))
			mensajes.setText("Las blancas ganan!!");
		else if (j.getNumFichas(Juego.BLANCAS)<j.getNumFichas(Juego.NEGRAS))
			mensajes.setText("Las negras ganan!!");
		else
		    mensajes.setText("Empate!!"); 
		*/     	
	}
	public void finPartida(){
		System.out.println("Fin de la partida");
		mensajes.setText("Fin de la partida");
		jB.setEnabled(true);
		jN.setEnabled(true);
		pasar.setEnabled(false);
		nueva.setEnabled(true);
		ultimo.setText("");
		p.calculaResultado();
		int nB=p.jugadorBlancas().getNumeroCapturas();
		int nN=p.jugadorNegras().getNumeroCapturas();
		if(nB>nN){
			resul.setText("Ganan Blancas "+nB+" a "+nN);
			String res="Jugador de negras: "+nN+"\nJugador de blancas: "+nB+"\nHan ganado Blancas";
			JOptionPane.showMessageDialog(new JFrame(),res,"Resultado final",JOptionPane.INFORMATION_MESSAGE);
		}else if(nB<nN){
			resul.setText("Ganan Negras "+nN+" a "+nB);
			String res="Jugador de negras: "+nN+"\nJugador de blancas: "+nB+"\nHan ganado Negras";
			JOptionPane.showMessageDialog(new JFrame(),res,"Resultado final",JOptionPane.INFORMATION_MESSAGE);
		}else{
			JOptionPane.showMessageDialog(new JFrame(),"Hay empate","Resultado final",JOptionPane.INFORMATION_MESSAGE);
		}
		//que salte un cuadro de dialogo o similar con el resultado
	}
	public static void main(String[] args) {
		new Interfaz();   
	}
}

