package go.interfaz;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import go.*;
import go.jugadores.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.CompoundBorder;

/**
 * @author  emi
 */
public class PanelTablero extends JPanel implements MouseListener {
	/**
	 * @uml.property  name="p"
	 * @uml.associationEnd  
	 */
	private Partida p;
	public final static Color COLOR_TABLERO = new Color(255,128,70);
	public final static int TAM_CASILLA = 40;
	public final static int TAM_FICHA= 35;
	public final static int MARGEN_CASILLA = (TAM_CASILLA - TAM_FICHA)/2;
	
	public PanelTablero() {
		super();
		setBackground(COLOR_TABLERO);
		setPreferredSize(new Dimension(TAM_CASILLA*9+2, TAM_CASILLA*9+2));
		addMouseListener(this);
		this.setBorder(new CompoundBorder(BorderFactory.createLineBorder(Color.black,3),BorderFactory.createRaisedBevelBorder()));
	}
	public void setPartida(Partida p){
		this.p=p;
	}
	private void dibujaFicha(Graphics g, int color, int fila, int col) {
		Color colorAct;
		colorAct = g.getColor();
		if (color==1) g.setColor(Color.white);
		else  g.setColor(Color.black);
		g.fillOval(col*TAM_CASILLA+MARGEN_CASILLA, fila*TAM_CASILLA+MARGEN_CASILLA, TAM_FICHA, TAM_FICHA);
		g.setColor(colorAct);
	}
	public void dibujaEstrella(Graphics g,int f, int c){
	Color colorAct =g.getColor();
	g.fill3DRect(f,c,3,3,true);
	g.setColor(colorAct);
	}
	public void paint(Graphics g) {
		int lin,f,c,color;
		super.paint(g);
		//dibujar lneas
		for(lin=0;lin<=8;lin++) {
			//horizontales
			g.drawLine(20, TAM_CASILLA*lin+20, TAM_CASILLA*8+20, TAM_CASILLA*lin+20);
			//verticales
			g.drawLine(TAM_CASILLA*lin+20, 20, TAM_CASILLA*lin+20, TAM_CASILLA*8+20);
		}
		dibujaEstrella(g,TAM_CASILLA*2+19,TAM_CASILLA*2+19);
		dibujaEstrella(g,TAM_CASILLA*6+19,TAM_CASILLA*2+19);
		dibujaEstrella(g,TAM_CASILLA*4+19,TAM_CASILLA*4+19);
		dibujaEstrella(g,TAM_CASILLA*2+19,TAM_CASILLA*6+19);
		dibujaEstrella(g,TAM_CASILLA*6+19,TAM_CASILLA*6+19);
		if(p==null) return;
		try{
			for(f=0;f<9;f++){
				for(c=0;c<9;c++){
					color=p.getTablero().getPosicion(f,c);
					if(color!=0) dibujaFicha(g, p.getTablero().getPosicion(f,c), f, c);
				}
			}
		}catch(Exception e){System.out.println(e);}
	}
	public void mouseClicked(MouseEvent e){
		Jugador jugador;
		Cruce cruce;
		if(p==null) return;
		jugador=p.jugadorActual();	
		if(jugador.getTipo()==Jugador.H) {		
			cruce = obtCruceXY((int)e.getPoint().getX(), (int)e.getPoint().getY());
			Ficha ficha=new Ficha(cruce,jugador.getColorJug());
			jugador.setJugada(ficha);	
		}
	}

	public void mousePressed(MouseEvent e){}

	public void mouseReleased(MouseEvent e){}

	public void mouseEntered(MouseEvent e){}

	public void mouseExited(MouseEvent e){}
	private Cruce obtCruceXY(int x, int y){
		Cruce cruce=new Cruce((int)(y/PanelTablero.TAM_CASILLA), (int)(x/PanelTablero.TAM_CASILLA));
		return cruce;
	}
}
