package go.jugadores;
import go.Cruce;
import go.Ficha;
import go.Partida;
import go.Cerco;
import go.Tablero;
import go.Estructura;
import go.jugadores.Jugador;
import java.util.*;

public class JugadorMaquina extends Jugador{
	
	public int nodos_evaluados=0;
	public int nodos_totales=0;
	
	// Profundidad hasta la que vamos a explorar el arbol de juego
	public final static int NIVEL_DEFECTO =2;
	private int esquina;
	public JugadorMaquina(int color){
		super(color,M);
	}
	public void setEsquina(int esq){
		this.esquina=esq;
	}
	public int getEsquina(){
		return this.esquina;
	}

	//*************************NOAIN***********************//
	//Para calcular una jugada vamos a llamar al siguiente metodo, el cual
	//podremos eleguir entre que versiones de la que implementemos queramos
	//que haga.
	
	public Ficha calcularMejorJugada(Partida p){

		Ficha mejor=null;
		
		
		//JUGADA DE APERTURA*************************************************
		Ficha prueba;
		if (p.getNumeroJugada()<4){
			if(p.getNumeroJugada()==0){
				mejor=new Ficha(2,2,2);//la ficha en el posiscion 2 2 y de color negro
			}
			if(p.getNumeroJugada()==1){
				prueba=new Ficha(2,2,1);
				if (estrategia_salida_vacia(p.getTablero(),prueba)){
					mejor=new Ficha(2,2,1);
				}
				else{
					mejor=new Ficha(6,2,1);
				}
			}
			if (p.getNumeroJugada()==2){
				prueba=new Ficha(2,2,2);
				if (estrategia_salida_vacia(p.getTablero(),prueba)){
					mejor=new Ficha(2,2,2);
				}
				else{
					prueba=new Ficha(6,2,2);
					if (estrategia_salida_vacia(p.getTablero(),prueba)){
						mejor=new Ficha(6,2,2);
					}
					else{
						mejor=new Ficha(2,6,2);
					}
				}
			}
			
			if (p.getNumeroJugada()==3){
				prueba=new Ficha(2,2,1);
				if (estrategia_salida_vacia(p.getTablero(),prueba)){
					mejor=new Ficha(2,2,1);
				}
				else{
					prueba=new Ficha(6,2,1);
					if (estrategia_salida_vacia(p.getTablero(),prueba)){
						mejor=new Ficha(6,2,1);
					}
					else{
						prueba=new Ficha(2,6,1);
						if (estrategia_salida_vacia(p.getTablero(),prueba)){
							mejor=new Ficha(2,6,1);
						}
						else{
							mejor=new Ficha(6,6,1);
						}
					}
				}
			}
		}
		
		else if (p.getNumeroJugada()==4){
			prueba=new Ficha(4,4,2);
			if (estrategia_salida_vacia(p.getTablero(),prueba)){
				mejor=new Ficha(4,4,2);
			}
			else{
				prueba=new Ficha(2,2,2);
				if (estrategia_salida_vacia(p.getTablero(),prueba)){
					mejor=new Ficha(2,2,2);
				}
				else{
					prueba=new Ficha(6,2,2);
					if (estrategia_salida_vacia(p.getTablero(),prueba)){
						mejor=new Ficha(6,2,2);
					}
					else{
						prueba=new Ficha(2,6,2);
						if (estrategia_salida_vacia(p.getTablero(),prueba)){
							mejor=new Ficha(2,6,2);
						}
						else{
							prueba=new Ficha(6,6,2);
							if (estrategia_salida_vacia(p.getTablero(),prueba)){
								mejor=new Ficha(6,6,2);
							}
							else{
								mejor=calcularJugadav4(p);
							}
						}
					}
				}
			}
		}
		
		else if (p.getNumeroJugada()==5){
			prueba=new Ficha(4,4,1);
			if (estrategia_salida_vacia(p.getTablero(),prueba)){
				mejor=new Ficha(4,4,1);
			}
			else{
				prueba=new Ficha(2,2,1);
				if (estrategia_salida_vacia(p.getTablero(),prueba)){
					mejor=new Ficha(2,2,1);
				}
				else{
					prueba=new Ficha(6,2,1);
					if (estrategia_salida_vacia(p.getTablero(),prueba)){
						mejor=new Ficha(6,2,1);
					}
					else{
						prueba=new Ficha(2,6,1);
						if (estrategia_salida_vacia(p.getTablero(),prueba)){
							mejor=new Ficha(2,6,1);
						}
						else{
							prueba=new Ficha(6,6,1);
							if (estrategia_salida_vacia(p.getTablero(),prueba)){
								mejor=new Ficha(6,6,1);
							}
							else{
								mejor=calcularJugadav4(p);
							}
						}
					}
				}
			}
		}
		
		// FIN JUGADA DE APERTURA*************************************************
		else{
			//mejor=calcularJugadav2(p);
			mejor=calcularJugadav4(p);
		}
			//Ficha mejor=calcularJugadav4(p);
			//la ficha que simulamos que es como pasar tiene los valores 10 10
			//porloque si llega esta ficha tendremos que pasar
			if(mejor.getFila()==10){
				mejor=null;
			}
			if(mejor==null)this.setPasar(true);
			nodos_totales=nodos_totales+nodos_evaluados;
			//System.out.println("Evaluados por MINIMAX en el turno "+num_turno+": "+nodos_evaluados+".\n");
			//System.out.println("En total, han sido evaludados "+total_nodos+" nodos.\n");
			System.out.println("LOS NODOS EVALUADOS SON:"+nodos_evaluados);
			System.out.println("LOS NODOS TOTALES SON:"+nodos_totales);
			nodos_evaluados=0;
		//}
			return mejor;
	}
	
	
	/*********************************************************************************/
	/****************** VERSIN 1: ENTRE TODOS SUS POSIBLES SUCESORES*****************/
	/************************VAMOS A ELEGIR UNO ALEATORIAMENTE************************/
	/*********************************************************************************/
	
	public Ficha calcularJugadav1(Partida p){
		//pos ser la ficha que voy a devolver, es decir la mejor jugada
		Ficha pos=null;
		//hago una copia de la partida
		Partida copia=p.copiaPartida();
		//en jugadas voy a tener una lista con todos posibles jugadas(es decir del tipo ficha)
		ArrayList<Ficha> jugadas=todas(copia);
		//emto en el entero la cuantas posibles jugadas hay
		int a=jugadas.size();
		//si tengo alguna posible jugada eligo una al hazar y sino sera null
		if (a!=0){
			int ficha=(int)(Math.random()* a);
			pos=jugadas.get(ficha);
		}
		else pos=null;
		return pos;
	}
	
	
	
	/*********************************************************************************/
	/******************** VERSIN 2: TODDOS SUS POSIBLES SUCESORES SON****************/
	/*** SOMETIDOS A UNA HEURISTICA Y SE ESCOGE EL MEJOR ES DECIR LE QUE MAS TIENE****/
	/****************PARA ELLO UTILIZAMOS EL METOODO HEURISTICA***********************/
	/*********************************************************************************/
	
	/*EL METODO HEURISTICA Y EL fEVAL(LO UTILIZAREMOS EN LAS SIGUIENTES VERSIONES
	 SON DIFERENTES, YA QUE EL PRIMERO VA A MIRAR EL TABLERO ACTUAL Y UNA FICHA
	 PARA SABER SI PUEDE COMER, PERO EL FEVAL, VAMOS HA HACER EL MOV DE LA FICHA
	 Y VAMOS A VER CUANTO DE BUENO ES EL TABLERO QUE NOS QUEDA*/
	public Ficha calcularJugadav2(Partida p){
		//pos ser la ficha que voy a devolver, es decir la mejor jugada
		Ficha pos=null;
		//hago una copia de la partida
		Partida copia=p.copiaPartida();//***********************************
		//en jugadas voy a tener una lista con todos posibles jugadas(es decir del tipo ficha)
		ArrayList<Ficha> jugadas=todas(copia);
		//meto en el entero la cuantas posibles jugadas hay
		int a=jugadas.size();
		//si tengo alguna posible jugada calculo las heuristicas de todos sus
		//posibles movimientos
		int [] heuristicas = new int[a];//creo que sera a-1
		int [] posiciones = new int[a];//creo que sera a-1
		if (a!=0){
			for (int i=0;i<jugadas.size();i++){
				copia=p.copiaPartida();
				//pongo en la copia de la partida la ficha correspondiente
				//una vez que hemos puesta la ficha, vamos a evaluar cuanto de bueno
				//es nuestro tablero
				//LLAMO A LA FUNCION DE EVALUACION CON LA JUGADA ACTUAL Y
				//EL POSIBLE SUCESOR(FICHA)
				//copia.poner(jugadas.get(i));
				int valor_heuristico=heuristicav2(p,jugadas.get(i));
				heuristicas[i]=valor_heuristico;
				
			}
		}
		else pos=null;
		
		//UNA VEZ AQUI TENEMOS EN UNA TABLA TODAS LAS HEURISTICAS DE LOS SUCESORES DEL LA SITUACION ACTUAL,
		//SOLO TENEMOS QUE COGER EL MAYOR DE ELLOS, Y SI EL NUMERO MAYOR COINCIDE ENTRE ALGUNO DE ELLOS, 
		//PUES LO HACEMOS DE FORMA ALEATORIA ENTRE ELOOS
		int cuantos=0,j,elegido=0,num=0;
		int puntos=-10000;
		for (j=0;j<jugadas.size();j++){
			//
			if (heuristicas[j]==puntos){
				cuantos ++;
				posiciones[num]=j;
				num ++;
			}
			if (heuristicas[j]>puntos){
				num=0;
				elegido=j;
				puntos=heuristicas[j];
				cuantos =1;
				posiciones[num]=elegido;
				num ++;
			}
		}
		
		if (cuantos==1){
			pos=jugadas.get(elegido);
		}
		else{
			int ficha=(int)(Math.random()* a);
			pos=jugadas.get(ficha);
		}
		return pos;
	}


	//FUNCION DE EVALUACION PARA EL MINIMAX Y PARA EL MINIMAX-PODA ALFA BETA
	public int heuristicav2(Partida p,Ficha f){
		int puntos=0;
		if (capturo(p,f)) puntos=100;
		return puntos;
	}
	
	/*********************************************************************************/
	/************************** VERSIN 3: MINIMAX ***********************************/
	/***************************UTILIZARA EL METOODO fEVALminimax****************************/
	/*********************************************************************************/
	
	
	public Ficha calcularJugadav3(Partida p){
		
		//Nos pasan la partida, y nos vamos a encargar de hacer el minimax, vamos
		//a necesitar, el una copia del tablero actual, copia del tablero anterior ya
		//que lo necesitaremos para no romper la regla del ko
		
		Tablero anterior=new Tablero(p.getAnterior(),0);
		
		//pos ser la ficha que voy a devolver, es decir la mejor jugada
		Ficha pos=null;
		//TURNO = 1 SI ES EL TURNO DE BLANCAS Y =2 CUANDO ES NEGRAS**************
		int jugador_max = p.getTurno();
		//System.out.println("el turno es de " + p.getTurno());
		//lo hago para saber el turno ya que tengo que cambiar cada vez en el minimax
		int turno=p.getTurno();
		
		//esto para el minimax no hace falta en si, pero lo voy a ir pasando en las
		//funciones, para poderlo utilizar en la heuristica, ya que para cada
		//posible ficha para mover, le voy a pasar a la heuristica cuantas fichas
		//van a ser comidas con ella, ya que tendra un peso importante
		int capturadas_blancas=p.jugadorBlancas().getNumeroCapturas();
		int capturadas_negras=p.jugadorNegras().getNumeroCapturas();
		//System.out.println("ANTES DE ENTRAR AL MINIMAX BLANCAS: " + p.jugadorBlancas().getNumeroCapturas());
		//System.out.println("ANTES DE ENTRAR AL MINIMAX NEGRAS: " + p.jugadorNegras().getNumeroCapturas());
		// Empiezo con mi turno (MAX)
		//int nodos_evaluados=0;
		
		//hago la copia del tablero para pasarselo al minimax
		//le pasamos una copia del tablero actual, a quien le toca el turno,la ficha
		//en la cual quedara la ficha con mejor heuristica,jug_max, y las capturadas
		//en el estado actual por cada uno
		Tablero t= new Tablero(p.getTablero(),0);
		pos = minimax(t,NIVEL_DEFECTO,turno,pos,jugador_max,anterior,capturadas_blancas,capturadas_negras,p.getNumeroJugada()).getFicha();
		return pos;
	}
	
	// Devuelve el valor final segun la funcion de evaluacion aplicada
	// a cada nodo y propagada hacia arriba
	public Estructura minimax(Tablero p,int profundidad,int turno,Ficha f_mover,int jugador_max,Tablero anterior,int capturadas_blancas,int capturadas_negras,int numero_jugada){
	
		//utilizaremos la clase estructura tiene dos campos, en uno guardaremos
		//la heuristica, y en el otro a la ficha a la cual corresponde dicha heu, y
		//para mover miramos cual es el jugador que ha llamado a minimax.
		int num_jug=numero_jugada;
		int cap_blan=0;
		int cap_neg=0;
		cap_blan=capturadas_blancas;
		cap_neg=capturadas_negras;
		Estructura actual;
		actual=new Estructura();
		
		// Si ha llegado a un nodo del nivel maximo de profundidad miramos su heuristica
  		// Y evalua el nodo llamando a fEval.
		//TENDRE QUE PONER EN VEZ DE FINPARTIDA, LO DE LAS FICHAS SI ES MAYOR DE 81
  		if ((profundidad==0) || (num_jug>81)){
  			//System.out.println("profundida 0");
  			//meto en heruistica la que le corresponde, junto a la ficha que es
  			actual.setHeuristica(fEvalminimax(p,anterior,jugador_max,cap_blan,cap_neg));
  			actual.setFicha(f_mover);
  			nodos_evaluados ++;
  			// Actualizo el numero de nodos evaluados
  			//nodos_evaluados ++;
  			//System.out.println(nodos_evaluados);
  			//System.out.println("CON PROF 0 ES: "+actual.getFicha().getFila() + " col:" +actual.getFicha().getColumna()+ " son:"+actual.getHeuristica());
			
			return actual;
			
  		}
  		//y si no es profundidad 0 y tiene sucesores, pues seguimos tratando
		else{
			// Posibles sucesores del nodo actual, lo meto en el vector
			//en jugadas voy a tener una lista con todos posibles jugadas(
			//(es decir del tipo ficha)
			//me da igual poner 10,10,2 que 10,10,1 que 10,10,x
			Ficha pasar_ficha=new Ficha(10,10,10);
			ArrayList<Ficha> sucesores=new ArrayList<Ficha>();
			sucesores=sacar_sucesores(p,turno,anterior);
			sucesores.add(pasar_ficha);
			
			//for(int i=0;i<sucesores.size();i++){
			//	System.out.println("SUCESOR"+sucesores.get(i));
			//}
			
			
			
			//	si es el turno de max llamamos a maximizador
			if(jugador_max==turno)
				return maximizador(p,sucesores,profundidad,jugador_max,turno,anterior,cap_blan,cap_neg,num_jug);
			// si es el turno de min llamos a minimizador
		   	else
		   		return minimizador(p,sucesores,profundidad,jugador_max,turno,anterior,cap_blan,cap_neg,num_jug);
		}
	}
	
	//Ahora implementamos la funcino maximizador, que cogera al mejor de sus sucesores para max
	public Estructura maximizador(Tablero p,ArrayList<Ficha> sucesores, int profundidad,int jugador_max,int turno,Tablero anterior,int capturadas_blancas,int capturadas_negras,int nume_jugada){
		
		
			int num_jugada=nume_jugada;
			num_jugada ++;
		
			// Donde guardare el mejor sucesor
			Estructura mejor_suc;
			mejor_suc=new Estructura();
			// Para saber el sucesor que estoy tratando
			// y su heuristica asociada
			Estructura actual;
			actual=new Estructura();
			//En vez de usar la partida original, usamos una copia
	 		Tablero copia;
	 		Tablero nuevo_anterior;
	 		
	 		mejor_suc.setHeuristica(-999999999);
	 		
			//Cambiar turno
	 		int turno_jugador=-1;
	 		if (turno== 1){
				turno_jugador=2;
			}
			else turno_jugador=1;
	 		
	 		int prof=profundidad-1;
	 		
	 		int cap_blan=0;
	 		int cap_neg=0;
	 		cap_blan=capturadas_blancas;
	 		cap_neg=capturadas_negras;
	 		
	 		int cap_blan_2=0;
	 		int cap_neg_2=0;
	 		
	 
	 		
			for(int i=0;i<sucesores.size();i++){
				cap_blan_2=cap_blan;
		 		cap_neg_2=cap_neg;
				// Conversion Integer --> int
				actual.setFicha(sucesores.get(i));
				//System.out.println("VOY A TRATAR EL SUCESORES" + actual.getFicha().getColorFicha()+ "en FILA" + actual.getFicha().getFila() + "COLUMNA" + actual.getFicha().getColumna());
					
		 		copia=new Tablero(p,0);//p.copiaPartida();
		 		//creo que tengo que poner que tablero anterior sea el original antes de
		 		//mover, y despues se mueve y se pasa el t
		 		nuevo_anterior=new Tablero(p,0);
		 		
		 		//si capturo sumo y sino pongo la ficha y a correr
		 		if (capturoFer(copia,actual.getFicha())){//si capturo actualizo las comidas

		 			//System.out.println("MAXI:Con la ficha: "+actual.getFicha()+"capturo");
		 			//System.out.println("SI VA A COMER Y CONTAMOS");
		 			if (actual.getFicha().getColorFicha()==1){//son blancas
		 				Tablero copia2=new Tablero(copia,0);
		 				//Ficha ficha2=new Ficha(actual.getFicha());

			 			//System.out.println("cap_blan que es que vale antes de cuentanumcap vale: "+ cap_blan);
		 				cap_blan_2 = cap_blan_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
		 				//System.out.println("MAXI como "+(cuentaNumCapturadas(copia2,actual.getFicha())));
			 			//System.out.println("MAXI captrudas blancas vale entonces:"+cap_blan_2);
		 				//System.out.println("cap_blan que es que vale despues de cuentanumcap vale: "+ cap_blan);
		 			}
		 			else{
		 				Tablero copia2=new Tablero(copia,0);
		 				//Ficha ficha2=new Ficha(actual.getFicha());
		 				cap_neg_2 = cap_neg_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
		 				//System.out.println("MAXI como "+(cuentaNumCapturadas(copia2,actual.getFicha())));
			 			//System.out.println("MAXI captrudas negras vale entonces:"+cap_neg_2);
		 			}
		 		}
		 		else{
		 			//System.out.println("NO VA A COMER");
		 		}
		 		//ponemos la ficha en el tablero
		 		ponerFer(copia,actual.getFicha());
		 		//y con este tablero resultante llamamos a minimax
				// Calculamos la heuristica del nodo actual
				actual.setHeuristica(minimax(copia,prof,turno_jugador,actual.getFicha(),jugador_max,nuevo_anterior,cap_blan_2,cap_neg_2,num_jugada).getHeuristica());
				//una vez que sale de la recursividad, si la heuristica que nos llega
				//es mayor que la que tenemos, pues como es el maximizador, cogeremos
				//la mayor, entonces el mejor sucesor sera el actual
				if(mejor_suc.getHeuristica()<actual.getHeuristica()){
					mejor_suc.setHeuristica(actual.getHeuristica());
					mejor_suc.setFicha(actual.getFicha());
				}
			}
			//System.out.println("LA ficha elegida es columna "+ mejor_suc.getFicha().getColumna() + "fila " + mejor_suc.getFicha().getFila());
			//System.out.println("LOS puntos de la ficha MAXI fila: "+mejor_suc.getFicha().getFila() + " col:" +mejor_suc.getFicha().getColumna()+ " son:"+mejor_suc.getHeuristica());
			return (mejor_suc);
			
		}
	
//	Ahora implementamos la funcino minimizador, que cogera al peor de sus sucesores para max
	public Estructura minimizador(Tablero p,ArrayList<Ficha> sucesores, int profundidad,int jugador_max,int turno,Tablero anterior,int capturadas_blancas,int capturadas_negras,int nume_jugada){
		
		/*
		ArrayList<Ficha> sucer=new ArrayList<Ficha>();
		for(int i=0;i<sucesores.size();i++){
			sucer.add(sucesores.get(i));
		}
		*/
		
		int num_jugada=nume_jugada;
		num_jugada ++;
		// Donde guardare el mejor sucesor
		Estructura mejor_suc;
		mejor_suc=new Estructura();
		// Para saber el sucesor que estoy tratando
		// y su heuristica asociada
		Estructura actual;
		actual=new Estructura();
		//En vez de usar la partida original, usamos una copia
 		Tablero copia;
 		Tablero nuevo_anterior;
 		
 		mejor_suc.setHeuristica(999999999);//**********borrar
 		
		//Cambiar turno
 		int turno_jugador=-1;
 		if (turno== 1){
			turno_jugador=2;
		}
		else turno_jugador=1;
 		
 		int prof=profundidad-1;

 		
 		int cap_blan=0;
 		int cap_neg=0;
 		cap_blan=capturadas_blancas;
 		cap_neg=capturadas_negras;
 		
 		int cap_blan_2=0;
 		int cap_neg_2=0;
 		

 		//ESTO LO HE HECHO DENTRO DEL FOR SOLO PARA TENER UNAS VARIABLES QUE 
 		//NOS DIGAN CUANTAS
 		//FICHAS COMEMOS SI MOVEMOS ESA FICHA, SERA IMPORTANTE PARA METERLA EN LA
 		//FUNCION DE HEURISTICA, XK TENDRA UN GRAN PESO
		for(int i=0;i<sucesores.size();i++){
			cap_blan_2 =cap_blan;
	 		cap_neg_2 =cap_neg;
			// Conversion Integer --> int
			actual.setFicha(sucesores.get(i));
			//System.out.println("VOY A TRATAR EL SUCESORES" + actual.getFicha().getColorFicha()+ "en FILA" + actual.getFicha().getFila() + "COLUMNA" + actual.getFicha().getColumna());
				
	 		copia=new Tablero(p,0);//p.copiaPartida();
	 		//creo que tengo que poner que tablero anterior sea el original antes de
	 		//mover, y despues se mueve y se pasa el t
	 		nuevo_anterior=new Tablero(p,0);
	 		
	 		//si capturo sumo y sino pongo la ficha y a correr
	 		if (capturoFer(copia,actual.getFicha())){//si capturo actualizo las comidas
	 			//System.out.println("MINI:Con la ficha: "+actual.getFicha()+"capturo");
	 			//System.out.println("SI VA A COMER Y CONTAMOS");
	 			if (actual.getFicha().getColorFicha()==1){//son blancas
	 				Tablero copia2=new Tablero(copia,0);
	 				//Ficha ficha2=new Ficha(actual.getFicha());

		 			//System.out.println("cap_blan que es que vale antes de cuentanumcap vale: "+ cap_blan);
	 				cap_blan_2 = cap_blan_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
		 			//System.out.println("MINI:Y como "+(cuentaNumCapturadas(copia2,actual.getFicha())));
		 			//System.out.println("MINI:y captrudas blancas vale entonces:"+cap_blan_2);
	 			}
	 			else{
	 				Tablero copia2=new Tablero(copia,0);
	 				//Ficha ficha2=new Ficha(actual.getFicha());
	 				cap_neg_2 = cap_neg_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
	 				//System.out.println("MINI:Y como "+(cuentaNumCapturadas(copia2,actual.getFicha())));
		 			//System.out.println("MINI:y captrudas negras vale entonces:"+cap_neg_2);
	 			
	 			}
	 		}
	 		else{
	 			//System.out.println("NO VA A COMER");
	 		}
	 		//ponemos la ficha en el tablero
	 		ponerFer(copia,actual.getFicha());
	 		//y con este tablero resultante llamamos a minimax
			// Calculamos la heuristica del nodo actual
			actual.setHeuristica(minimax(copia,prof,turno_jugador,actual.getFicha(),jugador_max,nuevo_anterior,cap_blan_2,cap_neg_2,num_jugada).getHeuristica());
			//una vez que sale de la recursividad, si la heuristica que nos llega
			//es mayor que la que tenemos, pues como es el maximizador, cogeremos
			//la mayor, entonces el mejor sucesor sera el actual
			if(mejor_suc.getHeuristica()>actual.getHeuristica()){
				mejor_suc.setHeuristica(actual.getHeuristica());
				mejor_suc.setFicha(actual.getFicha());
			}
		}
		//System.out.println("LA ficha elegida es columna "+ mejor_suc.getFicha().getColumna() + "fila " + mejor_suc.getFicha().getFila());
		//System.out.println("LOS puntos de la ficha MINI fila: "+mejor_suc.getFicha().getFila() + " col:" +mejor_suc.getFicha().getColumna()+ " son:"+mejor_suc.getHeuristica());
		return (mejor_suc);
	}
	
//IMPORTANTE, O VOY PASANDO EL NUMERO DE CAPTURAS DE CADA UNO, O PASA EL jugador blancas y negras
	
	public int fEvalminimax(Tablero t,Tablero ant,int jugador_max,int capturadas_blancas,int capturadas_negras){
		
		//LE DOY BASTANTE IMPORTANCIA A LAS COMIDAS, PERO AHORA LE TENDREMOS QUE DAR AL RESULTADO
		int puntos=0;
		//si jugador_max es blancas
		if (jugador_max==1){
			puntos=(capturadas_blancas-capturadas_negras)*70;
		}
		//si jugador_max es negras
		if (jugador_max==2){
			puntos=(capturadas_negras-capturadas_blancas)*70;
		}
		
		int mias_peligro=0;
		if (jugador_max==1){
			//LE PASO SOLO EL TABLERO?
			mias_peligro=miasEnPeligroFer(t,ant,1)*10;
		}
		else{
			mias_peligro=miasEnPeligroFer(t,ant,2)*10;
		}
		mias_peligro=mias_peligro * 30;
		
		int suyas_peligro=0;
		if (jugador_max==1){
			//LE PASO SOLO EL TABLERO?
			suyas_peligro=suyasEnPeligroFer(t,ant,1);
		}
		else{
			suyas_peligro=suyasEnPeligroFer(t,ant,2);
		}
		//System.out.println("mias en peligro hay:"+ mias_peligro);
		//System.out.println("suyas en peligro hay:"+ suyas_peligro);
		
		
		suyas_peligro=suyas_peligro * 30;
		puntos=puntos - mias_peligro;
		puntos=puntos + suyas_peligro;
		
		int mis_huecos=0;
		int sus_huecos=0;
		
		mis_huecos=calcular_mis_huecos_capturados(t,jugador_max);
		sus_huecos=calcular_sus_huecos_capturados(t,jugador_max);
		
		puntos=puntos + (mis_huecos * 70);
		puntos=puntos - (sus_huecos * 70);
		
		/*
		ArrayList<Ficha> lista=new ArrayList<Ficha>();
		//Jugador yo=p.jugadorActual();
		//int color=yo.getColorJug();
		//Partida copia=null;
		for(int f=0;f<t.getTam();f++){
			for(int c=0;c<t.getTam();c++){
				//copia=p.copiaPartida();
				//System.out.println("AQUI SI");
				
				if(t.getPosicion(f,c)==jugador_max){
					lista.add(new Ficha(f,c,jugador_max));
				}
			}
		}
		int unidas=0;
		int x;
		for(x=0;x<lista.size();x++){
			if(vecinosy_DiagonalesVacias(t,lista.get(x))){
					
			}
			else{
				unidas ++;
			}
		}
		puntos=puntos + unidas;
		*/
		
		//System.out.println("CAPTURADAS BLANCAS" + capturadas_blancas);
		return puntos;
	}
	
	
	
	
	/*********************************************************************************/
	/************************** VERSIN 4: MINIMAX CON PODA ALFA-BETA ***********************************/
	/***************************UTILIZARA EL METOODO fEVALminimax****************************/
	/*********************************************************************************/
	
	
public Ficha calcularJugadav4(Partida p){
		
		
		int alfa=-999999999;
		int beta=999999999;
		
		//el constructor del tablero que utilizo aqui, es el hecho por mi, el 
		//segundo campo no hace nada, solo que lo puse para diferenciar entre
		//el constructor mmio al que estaba hecho
		
		Tablero anterior=new Tablero(p.getAnterior(),0);
		
		//pos ser la ficha que voy a devolver, es decir la mejor jugada
		Ficha pos=null;
		//TURNO = 1 SI ES EL TURNO DE BLANCAS Y =2 CUANDO ES NEGRAS**************
		int jugador_max = p.getTurno();
		System.out.println("el turno es de " + p.getTurno());
		//lo hago para saber el turno ya que tengo que cambiar cada vez en el minimax
		int turno=p.getTurno();
		
		int capturadas_blancas=p.jugadorBlancas().getNumeroCapturas();
		int capturadas_negras=p.jugadorNegras().getNumeroCapturas();
		// Empiezo con mi turno (MAX)
		//int nodos_evaluados=0;
		//LO NUEVO QUE VOY A HACER ES PASARLE EL TABLERO Y FUERA
		Tablero t= new Tablero(p.getTablero(),0);
		pos = minimaxab(t,NIVEL_DEFECTO,turno,pos,jugador_max,anterior,capturadas_blancas,capturadas_negras,alfa,beta,p.getNumeroJugada()).getFicha();
		return pos;
	}
	
	
	// Devuelve el valor final segun la funcion de evaluacion aplicada 
	// a cada nodo y propagada hacia arriba
	public Estructura minimaxab(Tablero p,int profundidad,int turno,Ficha f_mover,int jugador_max,Tablero anterior,int capturadas_blancas,int capturadas_negras,int alfa,int beta,int numero_jugada){
	
		int num_jug=numero_jugada;
		int cap_blan=0;
		int cap_neg=0;
		cap_blan=capturadas_blancas;
		cap_neg=capturadas_negras;
		Estructura actual;
		actual=new Estructura();
		
		
		//*****************************************************************//
  		//********************TENDRE QUE ARREGALAR PARRA QUE FIN PARTIDA TB
  		//SEA LO DE MAIMO 50 FICAHS CADA UNO, K NO CUENTA EL NUMERO DE FICHAS//
  		//*****************************************************************//
		//int jugador=turno;//p.getTurno();//1 si es blancas y 2 si es negras
		//hola
  		if ((profundidad==0) || (num_jug>81)){
  			//System.out.println("profundida 0");
  			actual.setHeuristica(fEvalminimax(p,anterior,jugador_max,cap_blan,cap_neg));//meto el valor de la heuristica en el ultimo nodo
  			actual.setFicha(f_mover);
  			nodos_evaluados ++;
  			// Actualizo el numero de nodos evaluados
  			//nodos_evaluados ++;
  			//System.out.println(nodos_evaluados);
			return actual;
  		}
  		//y si no es profundidad 0 y tiene sucesores
		else{
			// Posibles sucesores del nodo actual, lo meto en el vector
			//en jugadas voy a tener una lista con todos posibles jugadas(es decir del tipo ficha)
			
			Ficha pasar_ficha=new Ficha(10,10,10);
			ArrayList<Ficha> sucesores=new ArrayList<Ficha>();
			sucesores=sacar_sucesores(p,turno,anterior);//TABLERO,JUGADOR,TABLERO_ANT);
			sucesores.add(pasar_ficha);
			
			//	es el turno de max
			if(jugador_max==turno)
				return maximizadorab(p,sucesores,profundidad,jugador_max,turno,anterior,cap_blan,cap_neg,alfa,beta,num_jug);
			// es el turno de min
		   	else
		   		return minimizadorab(p,sucesores,profundidad,jugador_max,turno,anterior,cap_blan,cap_neg,alfa,beta,num_jug);
	   		
		}
	}
	
	//Ahora implementamos la funcino maximizador, que cogera al mejor de sus sucesores para max
	public Estructura maximizadorab(Tablero p,ArrayList<Ficha> sucesores, int profundidad,int jugador_max,int turno,Tablero anterior,int capturadas_blancas,int capturadas_negras,int alfa,int beta,int nume_jugada){
			// Donde guardare el mejor sucesor
		
			int num_jugada=nume_jugada;
			num_jugada ++;
			Estructura mejor_suc;
			mejor_suc=new Estructura();
			// Para saber el sucesor que estoy tratando
			// y su heuristica asociada
			Estructura actual;
			actual=new Estructura();
			//En vez de usar la partida original, usamos una copia
	 		Tablero copia;
	 		Tablero nuevo_anterior;
	 		//*********************************AQUI
	 		
	 		mejor_suc.setHeuristica(-999999999);//**********borrar
	 		
			
	 		
	 		
	 		int turno_jugador=-1;
	 		if (turno== 1){
				turno_jugador=2;
			}
			else turno_jugador=1;
	 		
	 		int prof=profundidad-1;
	 		
	 		int cap_blan=0;
	 		int cap_neg=0;
	 		cap_blan=capturadas_blancas;
	 		cap_neg=capturadas_negras;
	 		
	 		int cap_blan_2=0;
	 		int cap_neg_2=0;
	 		
	 		 int i=0;
	 		 while((i<sucesores.size()) && (alfa<=beta)){		
				cap_blan_2=cap_blan;
		 		cap_neg_2=cap_neg;
				// Conversion Integer --> int
				actual.setFicha(sucesores.get(i));
				//System.out.println("VOY A TRATAR EL SUCESORES" + actual.getFicha().getColorFicha()+ "en FILA" + actual.getFicha().getFila() + "COLUMNA" + actual.getFicha().getColumna());
					
		 		copia=new Tablero(p,0);//p.copiaPartida();
		 		//creo que tengo que poner que tablero anterior sea el original antes de
		 		//mover, y despues se mueve y se pasa el t
		 		nuevo_anterior=new Tablero(p,0);
		 		
		 		
		 		//si capturo sumo y sino pongo la ficha y a correr
		 		if (capturoFer(copia,actual.getFicha())){//si capturo actualizo las comidas
		 			//System.out.println("SI VA A COMER Y CONTAMOS");
		 			if (actual.getFicha().getColorFicha()==1){//son blancas
		 				Tablero copia2=new Tablero(copia,0);
		 				//Ficha ficha2=new Ficha(actual.getFicha());

			 			//System.out.println("cap_blan que es que vale antes de cuentanumcap vale: "+ cap_blan);
		 				cap_blan_2 = cap_blan_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
		 				//System.out.println("cap_blan que es que vale despues de cuentanumcap vale: "+ cap_blan);
		 			}
		 			else{
		 				Tablero copia2=new Tablero(copia,0);
		 				//Ficha ficha2=new Ficha(actual.getFicha());
		 				cap_neg_2 = cap_neg_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
		 				
		 			}
		 		}
		 		else{
		 			//System.out.println("NO VA A COMER");
		 		}
		 		
		 		ponerFer(copia,actual.getFicha());
				
				
				// Calculamos la heuristica del nodo actual
				actual.setHeuristica(minimaxab(copia,prof,turno_jugador,actual.getFicha(),jugador_max,nuevo_anterior,cap_blan_2,cap_neg_2,mejor_suc.getHeuristica(),beta,num_jugada).getHeuristica());
				//if(fEval(t,jugador)<actual[0]){
				if(mejor_suc.getHeuristica()<actual.getHeuristica()){
					mejor_suc.setHeuristica(actual.getHeuristica());
					mejor_suc.setFicha(actual.getFicha());
				}
				i++;
			}
			//System.out.println("LA ficha elegida es columna "+ mejor_suc.getFicha().getColumna() + "fila " + mejor_suc.getFicha().getFila());
			return (mejor_suc);
			
		}
	
//	Ahora implementamos la funcino minimizador, que cogera al peor de sus sucesores para max
	public Estructura minimizadorab(Tablero p,ArrayList<Ficha> sucesores, int profundidad,int jugador_max,int turno,Tablero anterior,int capturadas_blancas,int capturadas_negras,int alfa,int beta,int nume_jugada){
		// Donde guardare el mejor sucesor
		int num_jugada=nume_jugada;
		num_jugada ++;
		
		Estructura mejor_suc;
		mejor_suc=new Estructura();
		// Para saber el sucesor que estoy tratando
		// y su heuristica asociada
		Estructura actual;
		actual=new Estructura();
		//En vez de usar la partida original, usamos una copia
 		Tablero copia;
 		Tablero nuevo_anterior;
 		
 		mejor_suc.setHeuristica(999999999);//
 		
 		int turno_jugador=-1;
 		if (turno== 1){
			turno_jugador=2;
		}
		else turno_jugador=1;
 		
 		int prof=profundidad-1;

 		//creo que tengo que poner que tablero anterior sea el original antes de
 		//mover, y despues se mueve y se pasa el t
 		
 		int cap_blan=0;
 		int cap_neg=0;
 		cap_blan=capturadas_blancas;
 		cap_neg=capturadas_negras;
 		
 		int cap_blan_2=0;
 		int cap_neg_2=0;
 		
 		int i=0;
		while((i<sucesores.size()) && (alfa<=beta)){
 			cap_blan_2=cap_blan;
	 		cap_neg_2=cap_neg;
			// Conversion Integer --> int
			actual.setFicha(sucesores.get(i));
			//para hacer el movimiento en la fial correspondiente(si es jugador
			//1 se hace en la fila de arriba y viceversa(o al reves)
	 		copia= new Tablero(p,0);//p.copiaPartida();
	 		nuevo_anterior=new Tablero(p,0);
	 		
	 		//si capturo sumo y sino pongo la ficha y a correr
	 		if (capturoFer(copia,actual.getFicha())){//si capturo actualizo las comidas
	 		//	System.out.println("SI VA A COMER Y CONTAMOS");
	 			if (actual.getFicha().getColorFicha()==1){//son blancas
	 				Tablero copia2=new Tablero(copia,0);
	 				//Ficha ficha2=new Ficha(actual.getFicha());

		 			//System.out.println("cap_blan que es que vale antes de cuentanumcap vale: "+ cap_blan);
	 				cap_blan_2 = cap_blan_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
	 				//System.out.println("cap_blan que es que vale despues de cuentanumcap vale: "+ cap_blan);
	 			}
	 			else{
	 				Tablero copia2=new Tablero(copia,0);
	 				//Ficha ficha2=new Ficha(actual.getFicha());
	 				cap_neg_2 = cap_neg_2 + (cuentaNumCapturadas(copia2,actual.getFicha()));
	 				
	 			}
	 		}
	 		else{
	 		//	System.out.println("NO VA A COMER");
	 		}
	 		//tengo que poner la ficha y actualizar tablero y tablero anterior
	 		//antes de poner
			ponerFer(copia,actual.getFicha());
			
			
			// Calculamos la heuristica del nodo actual
			actual.setHeuristica(minimaxab(copia,prof,turno_jugador,actual.getFicha(),jugador_max,nuevo_anterior,cap_blan_2,cap_neg_2,alfa,mejor_suc.getHeuristica(),num_jugada).getHeuristica());

			//if(fEval(t,jugador)<actual[0]){
			if(mejor_suc.getHeuristica()>actual.getHeuristica()){
				mejor_suc.setHeuristica(actual.getHeuristica());
				mejor_suc.setFicha(actual.getFicha());
			}
			i++;
		}
		return (mejor_suc);
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	
	
	
	
	/**************************************************************************/
	/**************************************************************************/
	/*********METODOS PARA HACER HEURISTICAS GRAN PARTE HECHOS POR MI**********/
	/**************************************************************************/
	/**************************************************************************/
	
	//mirar vecinos te va  sacar todos los vecinos que estan conectados
	public boolean capturo(Partida p, Ficha jugada){
		Partida mia=p.copiaPartida();
		ArrayList<Cerco> vecinos=mia.mirarVecinos(mia.getTablero(),jugada);
		Iterator<Cerco> i=vecinos.iterator();
		while(i.hasNext()){
			Cerco vecino=i.next();
			if((vecino.getAmo()!=jugada.getColorFicha())&&(vecino.getLibertades()==1))return true;
		}
		return false;
	}
	
	/**
	   * Funcin que devuelve una lista con todos los posibles sucesores de un estado dado
	   * @param p Una partida
	   * @return mov Lista de las posibles jugadas a realizar en esa partida
	   */ 
	public ArrayList<Ficha> todas(Partida p){
		ArrayList<Ficha> mov=new ArrayList<Ficha>();
		Jugador yo=p.jugadorActual();
		int color=yo.getColorJug();
		Partida copia=null;
		for(int f=0;f<p.getTablero().getTam();f++){
			for(int c=0;c<p.getTablero().getTam();c++){
				copia=p.copiaPartida();
				//System.out.println("AQUI SI");
				if(copia.puedoPoner(new Ficha(f,c,color))){
					mov.add(new Ficha(f,c,color));
				}
				//System.out.println("AQUI NO");
			}
		}
		return mov;
	}
	
	public String getNombre(){
		return "Mquina";
	}
	
	/*MIS FUNCIONES****************************************/
	
	//SACAR SUCESORES POR MI, meto el tablero acutal, el jugador que le toca,
	//y el tablero anterio(xk tengo que comprobar que el tablero que se va a llegar
	//no sea el mismo que el de que habia antes que el del estado actual)
	
	public ArrayList<Ficha> sacar_sucesores(Tablero t,int jugador,Tablero anterior){
		ArrayList<Ficha> mov=new ArrayList<Ficha>();
		//Jugador yo=p.jugadorActual();
		//int color=yo.getColorJug();
		//Partida copia=null;
		for(int f=0;f<t.getTam();f++){
			for(int c=0;c<t.getTam();c++){
				//copia=p.copiaPartida();
				//System.out.println("AQUI SI");
				if(sePuedePonerFer(t,anterior,jugador,new Ficha(f,c,jugador))){
					mov.add(new Ficha(f,c,jugador));
				}
				//System.out.println("AQUI NO");
			}
		}
		return mov;
	}
	
	//tengo que pasar el nuevo y el viejo tableropara saber si puedo o no puedo poner
	public boolean sePuedePonerFer(Tablero t,Tablero anterior,int jugador,Ficha ficha){
		boolean puedo=false,ko=false;
		if(t.getPosicion(ficha)!=0) return false;
		int lib=cuentaLiber(t,ficha);
		ArrayList<Cerco> vecinos=mirarVecinosFer(t,ficha);
		Cerco vecino=null;
		if(lib==0){
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				vecino=(Cerco)i.next();
				if(vecino.getAmo()==ficha.getColorFicha()){
					if(vecino.getLibertades()>1)puedo=true;
				}else{
					if(vecino.getLibertades()<2){
						t.setPosicion(ficha);
						t.setPosicion(vecino.getListaCruces().get(0).getFila(),vecino.getListaCruces().get(0).getColumna(),0);
						if(hayKo(t,anterior)) ko=true;
						else puedo=true;
						t.setPosicion(ficha.getFila(),ficha.getColumna(),0);
						t.setPosicion(vecino.getListaCruces().get(0).getFila(),vecino.getListaCruces().get(0).getColumna(),vecino.getAmo());
					}
				}
			}
		}else puedo=true;
		if(ko)return false;
		return puedo;
	}
	
	//CUanta libertadas para un tablero y para un cerco
	public int cuentaLiber(Tablero temp,Cerco yo){
		int lib=0,f,c;
		Iterator<Cruce> i=yo.getListaCruces().iterator();
		while(i.hasNext()){
			Cruce objetivo=i.next();
			//Miramos el vecino norte
			f=objetivo.getFila()-1;
			c=objetivo.getColumna();
			//Si el valor de la posicion es 0 la marcamos poniendolo a 9
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
			//Miramos el vecino sur
			f=objetivo.getFila()+1;
			c=objetivo.getColumna();
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
			//Miramos el vecino este
			f=objetivo.getFila();
			c=objetivo.getColumna()+1;
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
			//Miramos el vecino oeste
			f=objetivo.getFila();
			c=objetivo.getColumna()-1;
			if(temp.getPosicion(f, c)==0) temp.marcaPos(f,c);
		}
		for(f=0;f<temp.getTam();f++){
			for(c=0;c<temp.getTam();c++){
				if(temp.getPosicion(f, c)==9){
					lib=lib+1;
					temp.resetPosicion(f,c);
				}
			}
		}
		return lib;
	}
	//cuenta libertades para un tablero y una ficha
	public int cuentaLiber(Tablero tab, Ficha ficha){
		int lib=0;
		if(tab.getPosicion(ficha.getFila()-1,ficha.getColumna())==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila()+1,ficha.getColumna())==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila(),ficha.getColumna()-1)==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila(),ficha.getColumna()+1)==0)lib=lib+1;
		return lib;
	}
	
	public ArrayList<Cerco> mirarVecinosFer(Tablero t,Ficha ficha){
		ArrayList<Cerco> lista=new ArrayList<Cerco>();
		Cerco vecino=null;
		//mirarVecinoNorte
		if(t.getPosicion(ficha.getFila()-1,ficha.getColumna())>0){
			vecino=t.getCerco(ficha.getFila()-1,ficha.getColumna(),t.getPosicion(ficha.getFila()-1, ficha.getColumna()));
			//vecino=new Cerco(t.getCerco(ficha.getFila()-1,ficha.getColumna(),t.getPosicion(ficha.getFila()-1, ficha.getColumna())));
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		//mirarVecinoSur
		if(t.getPosicion(ficha.getFila()+1,ficha.getColumna())>0){
			vecino=t.getCerco(ficha.getFila()+1,ficha.getColumna(),t.getPosicion(ficha.getFila()+1, ficha.getColumna()));
			//vecino=new Cerco(t.getCerco(ficha.getFila()-1,ficha.getColumna(),t.getPosicion(ficha.getFila()-1, ficha.getColumna())));
			
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		//mirarVecinoEste
		if(t.getPosicion(ficha.getFila(),ficha.getColumna()+1)>0){
			vecino=t.getCerco(ficha.getFila(),ficha.getColumna()+1,t.getPosicion(ficha.getFila(), ficha.getColumna()+1));
			//vecino=new Cerco(t.getCerco(ficha.getFila()-1,ficha.getColumna(),t.getPosicion(ficha.getFila()-1, ficha.getColumna())));
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		//mirarVecinoOeste
		if(t.getPosicion(ficha.getFila(),ficha.getColumna()-1)>0){
			vecino=t.getCerco(ficha.getFila(),ficha.getColumna()-1,t.getPosicion(ficha.getFila(), ficha.getColumna()-1));
			//vecino=new Cerco(t.getCerco(ficha.getFila()-1,ficha.getColumna(),t.getPosicion(ficha.getFila()-1, ficha.getColumna())));
			if(!vecino.marcado()){
				lista.add(vecino);
				vecino.marcar();
			}
		}
		desmarcarVecinos(lista);
		return lista;
	}
	
	public void desmarcarVecinos(ArrayList<Cerco> listaVecinos){
		Iterator<Cerco> i=listaVecinos.iterator();
		while(i.hasNext()){
			Cerco vecino=(Cerco)i.next();
			vecino.desmarcar();
		}
	}
	
	//TENGO QUE GUARDAR EL TABLERO ANTERIOR. PARA SABER SI HAY KO A VER COMO LO ARREGLO
	public boolean hayKo(Tablero ahora,Tablero anterior){
		if(anterior.igualConf(ahora)){
			//System.out.println("hay ko");
			return true;
		}
		return false;
	}
	
	
	
	
	public void ponerFer(Tablero t,Ficha ficha){
		if (ficha.getFila()==10){
			//no hago nada porque simulamos que cuando llega la ficha con 10 10 10 es pasar,
			//porloque el tablero quedara igual, porloque no har nada
		}
		else{
			ArrayList<Cerco> vecinos=mirarVecinosFer(t,ficha);
			Cerco vecino=null;
			if(vecinos.isEmpty()){
				//if(!getListaMov().isEmpty()) setAnterior(getTablero().copiaTablero());
				//jugadorActual().addMovimiento(ficha);
				//addMov(ficha);
				
				t.setPosicion(ficha);
				Cerco yo=new Cerco(ficha,cuentaLibertadesFer(t,ficha));
				t.meteCerco(yo);
				}
			else{
				//if(!getListaMov().isEmpty()) setAnterior(getTablero().copiaTablero());
				Cerco yo=new Cerco(ficha);
				t.setPosicion(ficha);
				t.meteCerco(yo);
				Iterator<Cerco> i=vecinos.iterator();
				while(i.hasNext()){
					//System.out.println("recorriendo a los vecinitos");
					vecino=i.next();
					if(vecino.getAmo()==ficha.getColorFicha()){
						yo.getListaCruces().addAll(vecino.getListaCruces());
						vecino.getListaCruces().clear();
						t.sacaCerco(vecino);
					}else{
						vecino.setLibertades(vecino.getLibertades()-1);
						if(vecino.getLibertades()==0){
							capturarVecinoFer(t,vecino);
							//Pongo el lugar ocupado por el vecino a 0
							Iterator<Cruce> j=vecino.getListaCruces().iterator();
							while(j.hasNext()){
								Cruce objetivo=(Cruce)j.next();
								t.resetPosicion(objetivo);
							}
							//Lo elimino de la lista
							t.sacaCerco(vecino);
						}
					}
				}
				//jugadorActual().addMovimiento(ficha);
				yo.setLibertades(cuentaLiber(t,yo));
			}
		}
	}
	
	public int cuentaLibertadesFer(Tablero tab, Ficha ficha){
		int lib=0;
		if(tab.getPosicion(ficha.getFila()-1,ficha.getColumna())==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila()+1,ficha.getColumna())==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila(),ficha.getColumna()-1)==0)lib=lib+1;
		if(tab.getPosicion(ficha.getFila(),ficha.getColumna()+1)==0)lib=lib+1;
		return lib;
	}
	
	public void capturarVecinoFer(Tablero temp, Cerco capturado){
		//Me sumo las piezas capturadas
		//this.jugadorActual().sumaCapturas(capturado.getListaCruces().size());
		Iterator<Cruce> j=capturado.getListaCruces().iterator();
		int f,c;
		while(j.hasNext()){
			Cruce objetivo=(Cruce)j.next();
			Cerco vecino=null;
			ArrayList<Cerco> vecinos=new ArrayList<Cerco>();
			//Miramos el vecino norte
			f=objetivo.getFila()-1;
			c=objetivo.getColumna();
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			//Miramos el vecino sur
			f=objetivo.getFila()+1;
			c=objetivo.getColumna();
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			//Miramos el vecino este
			f=objetivo.getFila();
			c=objetivo.getColumna()+1;
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			//Miramos el vecino oeste
			f=objetivo.getFila();
			c=objetivo.getColumna()-1;
			if(temp.getPosicion(f, c)!=capturado.getAmo()&&temp.getPosicion(f, c)>0){
				vecino=temp.getCerco(f, c);
				if(!vecino.marcado()){
					vecino.marcar();
					vecinos.add(vecino);
				}
			}
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				vecino=(Cerco)i.next();
				vecino.setLibertades(vecino.getLibertades()+1);
				vecino.desmarcar();
			}
		}
	}
	
	public boolean capturoFer(Tablero t, Ficha jugada){
		//Pongo esto, he creado una fichas que ser pasar, y la identificado como 10 10 10
		if(jugada.getFila()==10){
			return false;
		}
		
		Tablero copia=new Tablero(t,0);
		ArrayList<Cerco> vecinos=mirarVecinosFer(copia,jugada);
		Iterator<Cerco> i=vecinos.iterator();
		while(i.hasNext()){
			Cerco vecino=i.next();
			//System.out.println("LIBERTADES de la ficha" + jugada + "es" + vecino.getLibertades());
			if((vecino.getAmo()!=jugada.getColorFicha())&&(vecino.getLibertades()==1))return true;
		}
		return false;
	}
	
	public int cuentaNumCapturadas(Tablero t,Ficha f){
		int dev=0;
		ArrayList<Cerco> vecinos=mirarVecinosFer(t,f);
		Cerco vecino=null;
		if(vecinos.isEmpty()){
			
		}
		else{
			//System.out.println("HAY VECINOS");
			//if(!getListaMov().isEmpty()) setAnterior(getTablero().copiaTablero());
			//Cerco yo=new Cerco(f);
			//t.setPosicion(f);
			//t.meteCerco(yo);
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				//System.out.println("recorriendo a los vecinitos");
				vecino=i.next();
				if(vecino.getAmo()==f.getColorFicha()){
					//System.out.println("Nada");
				}else{
					//System.out.println("Vecinos de otro color");
					if (vecino.getLibertades()-1==0){
						//System.out.println("dev antes vale: "+ dev);
						dev+=vecino.getListaCruces().size();
						//System.out.println("dev despues vale: "+ dev);
						//System.out.println("Los cruces del vecino son "+ vecino.getListaCruces().size());
					}
				}
			}
		}
		return dev;
	}
	
	
	//**********************************MIS FUNCIONES HEURISTICAS*********************
	
	//si tienes vecinos a sul alrededor te devolvera falso
	//YO
	
	//TENGO QUE SACAR LOS POSIBLES SUCESORES, Y HACER UN RECORRIDO POR TOD, SUMAR LAS POSIBLES
	//FICHAS QUE SE PUEDEN COMER Y SACAR ESE NUMERO, LE PASAREMOS EL TABLERO
	
	
	public int miasEnPeligroFer(Tablero t,Tablero ante,int turno){
		int en_peligro=0;
		Tablero copia= new Tablero(t,0);
		Tablero anterior=new Tablero(ante,0);
		ArrayList<Ficha> sucesores=new ArrayList<Ficha>();
		//saco todas las posibles jugadas que puedo hacer
		int turn=-1;
		if (turno==1){
			turn=2;
		}
		else{
			turn=1;
		}
		sucesores=sacar_sucesores(copia,turn,anterior);
		
		for(int j=0;j<sucesores.size();j++){
			
			ArrayList<Cerco> vecinos=mirarVecinosFer(copia,sucesores.get(j));
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				Cerco vecino=i.next();
				if((vecino.getLibertades()==1)&&(vecino.getAmo()!=sucesores.get(j).getColorFicha())){
						en_peligro= en_peligro + (cuentaNumCapturadas(copia,sucesores.get(j)));
				}
			}
		}
			//System.out.println("mias en peligro hay:"+ en_peligro);
			return en_peligro;
	}
	
	public int suyasEnPeligroFer(Tablero t,Tablero ante,int turno){
		int en_peligro=0;
		Tablero copia= new Tablero(t,0);
		Tablero anterior=new Tablero(ante,0);
		ArrayList<Ficha> sucesores=new ArrayList<Ficha>();
		//saco todas las posibles jugadas que puedo hacer
		sucesores=sacar_sucesores(copia,turno,anterior);
		
		for(int j=0;j<sucesores.size();j++){
			
			ArrayList<Cerco> vecinos=mirarVecinosFer(copia,sucesores.get(j));
			Iterator<Cerco> i=vecinos.iterator();
			while(i.hasNext()){
				Cerco vecino=i.next();
				if((vecino.getLibertades()==1)&&(vecino.getAmo()!=sucesores.get(j).getColorFicha())){
						en_peligro= en_peligro + (cuentaNumCapturadas(copia,sucesores.get(j)));
				}
			}
		}
		//System.out.println("suyas en peligro hay:"+ en_peligro);
		return en_peligro;
		
	}
	
	public int calcular_mis_huecos_capturados(Tablero t,int turno){
		int mias=0,suyas=0;
		ArrayList<Cruce> vacios=new ArrayList<Cruce>();
		Tablero copia= new Tablero(t);
		for(int f=0;f<copia.getTam();f++){
			for(int c=0;c<copia.getTam();c++){
				if(copia.getPosicion(f,c)==0)vacios.add(new Cruce(f,c));
			}
		}
		int turno_mio=-1;
		int turno_suyo=-1;
		
		if (turno==1){
			turno_mio=1;
			turno_suyo=2;
		}
		else{
			turno_mio=2;
			turno_suyo=1;
		}
		
		
		Iterator<Cruce> i=vacios.iterator();
		while(i.hasNext()){
			int vMias=0;
			int vSuyas=0;
			Cruce cruce=i.next();
			if(copia.getPosicion(cruce.getFila()-1,cruce.getColumna())==turno_mio )vMias++;
			if(copia.getPosicion(cruce.getFila()+1,cruce.getColumna())==turno_mio)vMias++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()-1)==turno_mio)vMias++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()+1)==turno_mio)vMias++;
			if(copia.getPosicion(cruce.getFila()-1,cruce.getColumna())==turno_suyo)vSuyas++;
			if(copia.getPosicion(cruce.getFila()+1,cruce.getColumna())==turno_suyo)vSuyas++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()-1)==turno_suyo)vSuyas++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()+1)==turno_suyo)vSuyas++;
			//LO HE CAMBIADO YO
			//if(vB>1)b++;
			//if(vN>1)n++;
			//tiene que tener mas de una y pero si tienen 2 cada uno no se cuenta
			if((vMias>1)&&(vSuyas<2))mias++;
			if((vSuyas>1)&&(vMias<2))suyas++;
		}
		
		return mias;
	}
	
	public int calcular_sus_huecos_capturados(Tablero t,int turno){
		int mias=0,suyas=0;
		ArrayList<Cruce> vacios=new ArrayList<Cruce>();
		Tablero copia= new Tablero(t);
		for(int f=0;f<copia.getTam();f++){
			for(int c=0;c<copia.getTam();c++){
				if(copia.getPosicion(f,c)==0)vacios.add(new Cruce(f,c));
			}
		}
		int turno_mio=-1;
		int turno_suyo=-1;
		
		if (turno==1){
			turno_mio=1;
			turno_suyo=2;
		}
		else{
			turno_mio=2;
			turno_suyo=1;
		}
		
		
		Iterator<Cruce> i=vacios.iterator();
		while(i.hasNext()){
			int vMias=0;
			int vSuyas=0;
			Cruce cruce=i.next();
			if(copia.getPosicion(cruce.getFila()-1,cruce.getColumna())==turno_mio )vMias++;
			if(copia.getPosicion(cruce.getFila()+1,cruce.getColumna())==turno_mio)vMias++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()-1)==turno_mio)vMias++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()+1)==turno_mio)vMias++;
			if(copia.getPosicion(cruce.getFila()-1,cruce.getColumna())==turno_suyo)vSuyas++;
			if(copia.getPosicion(cruce.getFila()+1,cruce.getColumna())==turno_suyo)vSuyas++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()-1)==turno_suyo)vSuyas++;
			if(copia.getPosicion(cruce.getFila(),cruce.getColumna()+1)==turno_suyo)vSuyas++;
			//LO HE CAMBIADO YO
			//if(vB>1)b++;
			//if(vN>1)n++;
			//tiene que tener mas de una y pero si tienen 2 cada uno no se cuenta
			if((vMias>1)&&(vSuyas<2))mias++;
			if((vSuyas>1)&&(vMias<2))suyas++;
		}
		//System.out.println("Territorio mio:"+mias);
		//System.out.println("Territorio suyo:"+suyas);
		
		return suyas;
	}
	
	
	public boolean vecinosy_DiagonalesVacias(Tablero t,Ficha f){
			
		//si es la esquina superior izquierda
		if (f.getFila()==0 && f.getColumna()==0){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila())+1,f.getColumna())!=0) || (t.getPosicion((f.getFila()),(f.getColumna())+1)!=0)){
				return false;
			}
		}
		
		//si es la esquina superior derecha
		else if (f.getFila()==0 && f.getColumna()==8){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila())-1,f.getColumna())!=0) || (t.getPosicion((f.getFila()),(f.getColumna())-1)!=0)){
				return false;
			}
		}
		
		//si es la esquina inferior  izquierda
		else if (f.getFila()==8 && f.getColumna()==0){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()+1)!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)){
				return false;
			}
		}
		
		//si es la esquina inferior  derecha
		else if (f.getFila()==8 && f.getColumna()==8){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()-1)!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)){
				return false;
			}
		}
		
		//si esta en la primera fila y en en otra columna,miro todas menos la superior
		else if (f.getFila()==0 && (f.getColumna()>0) && (f.getColumna()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()-1)!=0) || (t.getPosicion((f.getFila()),(f.getColumna())+1)!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)){
				return false;
			}
		}
		//si esta en la ultima fila y en en otra fila,miro todas menos en la de abajo
		else if (f.getFila()==8 && (f.getColumna()>0) && (f.getColumna()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()-1)!=0) || (t.getPosicion((f.getFila()),(f.getColumna())+1)!=0)||(t.getPosicion((f.getFila()+1),(f.getColumna()))!=0)){
				return false;
			}
		}
		
		//si esta en la primera columan y en otra filas
		
		else if (f.getColumna()==0 && (f.getFila()>0) && (f.getFila()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()+1),f.getColumna())!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()),(f.getColumna()+1))!=0)){
				return false;
			}
		}
		
		//si esta en la ultima columna y en otra filas
		else if (f.getColumna()==8 && (f.getFila()>0) && (f.getFila()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()+1),f.getColumna())!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()),(f.getColumna()-1))!=0)){
				return false;
			}
		}
		
		else if((f.getFila()>0)&&(f.getFila()<8)&&(f.getColumna()>0)&&(f.getColumna()<8)){
			if ((t.getPosicion((f.getFila()),f.getColumna()+1)!=0) || (t.getPosicion((f.getFila()+1),(f.getColumna()+1))!=0)||(t.getPosicion((f.getFila()+1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()+1),(f.getColumna())-1)!=0) || (t.getPosicion((f.getFila()),(f.getColumna())-1)!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna())-1)!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna())+1)!=0)){
				return false;
			}
				
		}
		
		//si llega aqui es que es falso, es decirno no tiene vecinos
		return true;
			
	}
	
	public boolean estrategia_salida_vacia(Tablero t,Ficha f){
		
		//si es la esquina superior izquierda
		if (f.getFila()==0 && f.getColumna()==0){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila())+1,f.getColumna())!=0) || (t.getPosicion((f.getFila()),(f.getColumna())+1)!=0)){
				return false;
			}
		}
		
		//si es la esquina superior derecha
		else if (f.getFila()==0 && f.getColumna()==8){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila())-1,f.getColumna())!=0) || (t.getPosicion((f.getFila()),(f.getColumna())-1)!=0)){
				return false;
			}
		}
		
		//si es la esquina inferior  izquierda
		else if (f.getFila()==8 && f.getColumna()==0){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()+1)!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)){
				return false;
			}
		}
		
		//si es la esquina inferior  derecha
		else if (f.getFila()==8 && f.getColumna()==8){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()-1)!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)){
				return false;
			}
		}
		
		//si esta en la primera fila y en en otra columna,miro todas menos la superior
		else if (f.getFila()==0 && (f.getColumna()>0) && (f.getColumna()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()-1)!=0) || (t.getPosicion((f.getFila()),(f.getColumna())+1)!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)){
				return false;
			}
		}
		//si esta en la ultima fila y en en otra fila,miro todas menos en la de abajo
		else if (f.getFila()==8 && (f.getColumna()>0) && (f.getColumna()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()),f.getColumna()-1)!=0) || (t.getPosicion((f.getFila()),(f.getColumna())+1)!=0)||(t.getPosicion((f.getFila()+1),(f.getColumna()))!=0)){
				return false;
			}
		}
		
		//si esta en la primera columan y en otra filas
		
		else if (f.getColumna()==0 && (f.getFila()>0) && (f.getFila()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()+1),f.getColumna())!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()),(f.getColumna()+1))!=0)){
				return false;
			}
		}
		
		//si esta en la ultima columna y en otra filas
		else if (f.getColumna()==8 && (f.getFila()>0) && (f.getFila()<8)){
			//si cualquiera de sus vecinos es distinto de 0 ya ta.
			if ((t.getPosicion((f.getFila()+1),f.getColumna())!=0) || (t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()),(f.getColumna()-1))!=0)){
				return false;
			}
		}
		
		else if((f.getFila()>0)&&(f.getFila()<8)&&(f.getColumna()>0)&&(f.getColumna()<8)){
			if ((t.getPosicion((f.getFila()),f.getColumna()+1)!=0) || (t.getPosicion((f.getFila()+1),(f.getColumna()+1))!=0)||(t.getPosicion((f.getFila()+1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()+1),(f.getColumna())-1)!=0) || (t.getPosicion((f.getFila()),(f.getColumna())-1)!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna())-1)!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna()))!=0)||(t.getPosicion((f.getFila()-1),(f.getColumna())+1)!=0) || (t.getPosicion((f.getFila()),(f.getColumna()))!=0)){
				return false;
			}
				
		}
		//si llega aqui es que es falso, es decirno no tiene vecinos
		return true;
			
	}
	
}